/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2002 from the
 * contents of Virt.xs. Do not edit this file, edit Virt.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Virt.xs"
/* -*- c -*-
 *
 * Copyright (C) 2006 Red Hat
 * Copyright (C) 2006-2007 Daniel P. Berrange
 *
 * This program is free software; You can redistribute it and/or modify
 * it under either:
 *
 * a) the GNU General Public License as published by the Free
 *   Software Foundation; either version 2, or (at your option) any
 *   later version,
 *
 * or
 *
 * b) the "Artistic License"
 *
 * The file "LICENSE" distributed along with this file provides full
 * details of the terms and conditions of the two licenses.
 */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <libvirt/virterror.h>
#include <libvirt/libvirt.h>

/*
 * On 32-bit OS (and some 64-bit) Perl does not have an
 * integer type capable of storing 64 bit numbers. So
 * we serialize to/from strings on these platforms
 */

long long
virt_SvIVll(SV *sv) {
#ifdef USE_64_BIT_ALL
    return SvIV(sv);
#else
    return strtoll(SvPV_nolen(sv), NULL, 10);
#endif
}

unsigned long long
virt_SvIVull(SV *sv) {
#ifdef USE_64_BIT_ALL
    return SvIV(sv);
#else
    return strtoull(SvPV_nolen(sv), NULL, 10);
#endif
}


#ifndef PRId64
#define PRId64 "lld"
#endif

SV *
virt_newSVll(long long val) {
#ifdef USE_64_BIT_ALL
    return newSViv(val);
#else
    char buf[100];
    int len;
    len = snprintf(buf, 100, "%" PRId64, val);
    return newSVpv(buf, len);
#endif
}

#ifndef PRIu64
#define PRIu64 "llu"
#endif

SV *
virt_newSVull(unsigned long long val) {
#ifdef USE_64_BIT_ALL
    return newSVuv(val);
#else
    char buf[100];
    int len;
    len = snprintf(buf, 100, "%" PRIu64, val);
    return newSVpv(buf, len);
#endif
}



void	ignoreVirErrorFunc(void * userData, virErrorPtr error) {
  /* Do nothing */
}

SV *
_sv_from_error (virErrorPtr error)
{
    HV *hv;

    hv = newHV ();

    /* Map virErrorPtr attributes to hash keys */
    (void)hv_store (hv, "code", 4, newSViv (error ? error->code : 0), 0);
    (void)hv_store (hv, "domain", 6, newSViv (error ? error->domain : VIR_FROM_NONE), 0);
    (void)hv_store (hv, "message", 7, newSVpv (error && error->message ? error->message : "Unknown problem", 0), 0);

    return sv_bless (newRV_noinc ((SV*) hv), gv_stashpv ("Sys::Virt::Error", TRUE));
}


void
_croak_error (virErrorPtr error)
{
    sv_setsv (ERRSV, _sv_from_error (error));

    /* croak does not return, so we free this now to avoid leaking */
    virResetError (error);

    croak (Nullch);
}

void
_populate_constant(HV *stash, char *name, int val)
{
    SV *valsv;

    valsv = newSViv(0);
    sv_setuv(valsv,val);
    newCONSTSUB(stash, name, valsv);
}

#define REGISTER_CONSTANT(name, key) _populate_constant(stash, #key, name)

static int
_domain_event_callback(virConnectPtr con,
		       virDomainPtr dom,
		       int event,
		       int detail,
		       void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSViv(event)));
    XPUSHs(sv_2mortal(newSViv(detail)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}

static void
_domain_event_free(void *opaque)
{
  SV *sv = opaque;
  SvREFCNT_dec(sv);
}

static int
_event_add_handle(int fd,
		  int events,
		  virEventHandleCallback cb,
		  void *opaque,
		  virFreeCallback ff)
{
    SV *cbref;
    SV *opaqueref;
    SV *ffref;
    int ret;
    int watch = 0;
    dSP;

    ENTER;
    SAVETMPS;

    cbref= sv_newmortal();
    opaqueref= sv_newmortal();
    ffref= sv_newmortal();

    sv_setref_pv(cbref, NULL, cb);
    sv_setref_pv(opaqueref, NULL, opaque);
    sv_setref_pv(ffref, NULL, ff);

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(fd)));
    XPUSHs(sv_2mortal(newSViv(events)));
    XPUSHs(cbref);
    XPUSHs(opaqueref);
    XPUSHs(ffref);
    PUTBACK;

    ret = call_pv("Sys::Virt::Event::_add_handle", G_SCALAR);

    SPAGAIN;

    if (ret == 1)
      watch = POPi;

    FREETMPS;
    LEAVE;

    if (ret != 1)
      return -1;

    return watch;
}

static void
_event_update_handle(int watch,
		     int events)
{
    dSP;

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(watch)));
    XPUSHs(sv_2mortal(newSViv(events)));
    PUTBACK;

    call_pv("Sys::Virt::Event::_update_handle", G_DISCARD);

    FREETMPS;
    LEAVE;
}

static int
_event_remove_handle(int watch)
{
    dSP;

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(watch)));
    PUTBACK;

    call_pv("Sys::Virt::Event::_remove_handle", G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
    return 0;
}

static int
_event_add_timeout(int interval,
		   virEventTimeoutCallback cb,
		   void *opaque,
		   virFreeCallback ff)
{
    SV *cbref;
    SV *opaqueref;
    SV *ffref;
    int ret;
    int timer = 0;
    dSP;

    ENTER;
    SAVETMPS;

    cbref = sv_newmortal();
    opaqueref = sv_newmortal();
    ffref = sv_newmortal();

    sv_setref_pv(cbref, NULL, cb);
    sv_setref_pv(opaqueref, NULL, opaque);
    sv_setref_pv(ffref, NULL, ff);

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(interval)));
    XPUSHs(cbref);
    XPUSHs(opaqueref);
    XPUSHs(ffref);
    PUTBACK;

    ret = call_pv("Sys::Virt::Event::_add_timeout", G_SCALAR);

    SPAGAIN;

    if (ret == 1)
      timer = POPi;

    FREETMPS;
    LEAVE;

    if (ret != 1)
      return -1;

    return timer;
}

static void
_event_update_timeout(int timer,
		      int interval)
{
    dSP;

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(timer)));
    XPUSHs(sv_2mortal(newSViv(interval)));
    PUTBACK;

    call_pv("Sys::Virt::Event::_update_timeout", G_DISCARD);

    FREETMPS;
    LEAVE;
}

static int
_event_remove_timeout(int timer)
{
    dSP;

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(timer)));
    PUTBACK;

    call_pv("Sys::Virt::Event::_remove_timeout", G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_open_auth_callback(virConnectCredentialPtr cred,
		    unsigned int ncred,
		    void *cbdata)
{
  dSP;
  int i, ret, success = -1;
  AV *credlist;

  credlist = newAV();

  ENTER;
  SAVETMPS;
  PUSHMARK(SP);

  for (i = 0 ; i < ncred ; i++) {
      HV *credrec = newHV();

      (void)hv_store(credrec, "type", 4, newSViv(cred[i].type), 0);
      (void)hv_store(credrec, "prompt", 6, newSVpv(cred[i].prompt, 0), 0);
      (void)hv_store(credrec, "challenge", 9, newSVpv(cred[i].challenge, 0), 0);
      (void)hv_store(credrec, "result", 6, newSVpv(cred[i].defresult, 0), 0);

      av_push(credlist, newRV_noinc((SV *)credrec));
  }
  SvREFCNT_inc((SV*)credlist);

  XPUSHs(newRV_noinc((SV*)credlist));
  PUTBACK;

  ret = call_sv((SV*)cbdata, G_SCALAR);

  SPAGAIN;

  if (ret == 1)
     success = POPi;

  for (i = 0 ; i < ncred ; i++) {
      SV **credsv = av_fetch(credlist, i, 0);
      HV *credrec = (HV*)SvRV(*credsv);
      SV **val = hv_fetch(credrec, "result", 6, 0);

      if (val && SvOK(*val)) {
	  STRLEN len;
	  char *result = SvPV(*val, len);
	  if (!(cred[i].result = malloc(len+1)))
	      abort();
	  memcpy(cred[i].result, result, len+1);
	  cred[i].resultlen = (unsigned int)len;
      } else {
	  cred[i].resultlen = 0;
	  cred[i].result = NULL;
      }
  }

  FREETMPS;
  LEAVE;

  return success;
}


#line 426 "Virt.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

#line 469 "Virt.c"

XS(XS_Sys__Virt__open); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__open)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "name, readonly");
    {
	SV *	name = ST(0);
	int	readonly = (int)SvIV(ST(1));
#line 425 "Virt.xs"
      const char *uri = NULL;
#line 486 "Virt.c"
	virConnectPtr	RETVAL;
#line 427 "Virt.xs"
      if (SvOK(name))
	  uri = SvPV_nolen(name);

      if (readonly) {
	RETVAL = virConnectOpenReadOnly(uri);
      } else {
	RETVAL = virConnectOpen(uri);
      }
      if (!RETVAL) {
	_croak_error(virGetLastError());
      }
#line 500 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt", (void*)RETVAL );



    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__open_auth); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__open_auth)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       croak_xs_usage(cv,  "name, readonly, creds, cb");
    {
	SV *	name = ST(0);
	int	readonly = (int)SvIV(ST(1));
	SV *	creds = ST(2);
	SV *	cb = ST(3);
#line 449 "Virt.xs"
      AV *credlist;
      virConnectAuth auth;
      int i;
      const char *uri = NULL;
#line 531 "Virt.c"
	virConnectPtr	RETVAL;
#line 454 "Virt.xs"
      if (SvOK(name))
	  uri = SvPV_nolen(name);

      if (SvOK(cb) && SvOK(creds)) {
	  memset(&auth, 0, sizeof auth);
	  credlist = (AV*)SvRV(creds);
	  auth.ncredtype = av_len(credlist) + 1;
	  Newx(auth.credtype, auth.ncredtype, int);
	  for (i = 0 ; i < auth.ncredtype ; i++) {
	    SV **type = av_fetch(credlist, i, 0);
	    auth.credtype[i] = SvIV(*type);
	  }

	  auth.cb = _open_auth_callback;
	  auth.cbdata = cb;
	  RETVAL = virConnectOpenAuth(uri,
				      &auth,
				      readonly ? VIR_CONNECT_RO : 0);
	  Safefree(auth.credtype);
      } else {
	  RETVAL = virConnectOpenAuth(uri,
				      virConnectAuthPtrDefault,
				      readonly ? VIR_CONNECT_RO : 0);
      }
      if (!RETVAL) {
	_croak_error(virGetLastError());
      }
#line 561 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt", (void*)RETVAL );



    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_restore_domain); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_restore_domain)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, from");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	const char *	from = (const char *)SvPV_nolen(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::restore_domain() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 489 "Virt.xs"
      if((virDomainRestore(con, from)) < 0) {
	_croak_error(virConnGetLastError(con));
      }
#line 598 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__get_library_version); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__get_library_version)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "void");
    {
#line 496 "Virt.xs"
      unsigned long version;
#line 618 "Virt.c"
	unsigned long	RETVAL;
	dXSTARG;
#line 498 "Virt.xs"
      if (virGetVersion(&version, NULL, NULL) < 0) {
	_croak_error(virGetLastError());
      }
      RETVAL = version;
#line 626 "Virt.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__get_conn_version); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__get_conn_version)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
#line 509 "Virt.xs"
      unsigned long version;
#line 647 "Virt.c"
	unsigned long	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::_get_conn_version() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 511 "Virt.xs"
      if (virConnectGetVersion(con, &version) < 0) {
	_croak_error(virConnGetLastError(con));
      }
      RETVAL = version;
#line 662 "Virt.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_type); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_type)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_type() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 522 "Virt.xs"
      RETVAL = virConnectGetType(con);
#line 692 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_uri); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_uri)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_uri() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 530 "Virt.xs"
      RETVAL = virConnectGetURI(con);
#line 722 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_node_info); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_node_info)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
#line 538 "Virt.xs"
      virNodeInfo info;
#line 743 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_node_info() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 540 "Virt.xs"
      if (virNodeGetInfo(con, &info) < 0) {
	_croak_error(virConnGetLastError(con));
      }
      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "model", 5, newSVpv(info.model, 0), 0);
      (void)hv_store (RETVAL, "memory", 6, newSViv(info.memory), 0);
      (void)hv_store (RETVAL, "cpus", 4, newSViv(info.cpus), 0);
      (void)hv_store (RETVAL, "mhz", 3, newSViv(info.mhz), 0);
      (void)hv_store (RETVAL, "nodes", 5, newSViv(info.nodes), 0);
      (void)hv_store (RETVAL, "sockets", 7, newSViv(info.sockets), 0);
      (void)hv_store (RETVAL, "cores", 5, newSViv(info.cores), 0);
      (void)hv_store (RETVAL, "threads", 7, newSViv(info.threads), 0);
#line 765 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_node_security_model); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_node_security_model)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
#line 560 "Virt.xs"
      virSecurityModel secmodel;
#line 787 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_node_security_model() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 562 "Virt.xs"
      if (virNodeGetSecurityModel(con, &secmodel) < 0) {
	_croak_error(virConnGetLastError(con));
      }
      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "model", 5, newSVpv(secmodel.model, 0), 0);
      (void)hv_store (RETVAL, "doi", 3, newSVpv(secmodel.doi, 0), 0);
#line 803 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_node_free_memory); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_node_free_memory)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
#line 575 "Virt.xs"
      unsigned long long mem;
#line 825 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_node_free_memory() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 577 "Virt.xs"
      if ((mem = virNodeGetFreeMemory(con)) == 0) {
	_croak_error(virConnGetLastError(con));
      }
      RETVAL = virt_newSVull(mem);
#line 839 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_node_cells_free_memory); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_node_cells_free_memory)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "con, start, end");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	start = (int)SvIV(ST(1));
	int	end = (int)SvIV(ST(2));
#line 591 "Virt.xs"
      unsigned long long *mem;
      int i, num;
#line 866 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_node_cells_free_memory() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 594 "Virt.xs"
      Newx(mem, end-start, unsigned long long);
      if ((num = virNodeGetCellsFreeMemory(con, mem, start, end)) < 0) {
	Safefree(mem);
	_croak_error(virConnGetLastError(con));
      }
      EXTEND(SP, num);
      for (i = 0 ; i < num ; i++) {
	SV *val = newSViv(mem[i]);
	PUSHs(sv_2mortal(val));
      }
      Safefree(mem);
#line 886 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_find_storage_pool_sources); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_find_storage_pool_sources)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "con, type, srcspec, flags=0");
    {
	virConnectPtr	con;
	const char *	type = (const char *)SvPV_nolen(ST(1));
	const char *	srcspec = (const char *)SvPV_nolen(ST(2));
	unsigned int	flags;
	char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::find_storage_pool_sources() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3));
	}
#line 614 "Virt.xs"
      if ((RETVAL = virConnectFindStoragePoolSources(con, type, srcspec, flags)) == NULL) {
	_croak_error(virConnGetLastError(con));
      }
#line 927 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_capabilities); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_capabilities)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
#line 625 "Virt.xs"
      char *xml;
#line 948 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_capabilities() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 627 "Virt.xs"
      if (!(xml = virConnectGetCapabilities(con))) {
	 _croak_error(virConnGetLastError(con));
      }
      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 963 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_max_vcpus); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_max_vcpus)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, type");
    {
	virConnectPtr	con;
	char *	type = (char *)SvPV_nolen(ST(1));
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_max_vcpus() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 640 "Virt.xs"
      if ((RETVAL = virConnectGetMaxVcpus(con, type)) < 0) {
	_croak_error(virConnGetLastError(con));
      }
#line 997 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_get_hostname); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_get_hostname)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
#line 650 "Virt.xs"
      char *host;
#line 1018 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::get_hostname() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 652 "Virt.xs"
      if ((host = virConnectGetHostname(con)) < 0) {
	_croak_error(virConnGetLastError(con));
      }
      RETVAL = newSVpv(host, 0);
      free(host);
#line 1033 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_num_of_domains); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_domains)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_domains() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 664 "Virt.xs"
      if ((RETVAL = virConnectNumOfDomains(con)) < 0) {
	_croak_error(virConnGetLastError(con));
      }
#line 1066 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_domain_ids); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_domain_ids)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, maxids");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxids = (int)SvIV(ST(1));
#line 675 "Virt.xs"
      int *ids;
      int i, nid;
#line 1091 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_domain_ids() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 678 "Virt.xs"
      Newx(ids, maxids, int);
      if ((nid = virConnectListDomains(con, ids, maxids)) < 0) {
        Safefree(ids);
	_croak_error(virConnGetLastError(con));
      }
      EXTEND(SP, nid);
      for (i = 0 ; i < nid ; i++) {
	PUSHs(sv_2mortal(newSViv(ids[i])));
      }
      Safefree(ids);
#line 1110 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_num_of_defined_domains); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_defined_domains)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_defined_domains() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 694 "Virt.xs"
      if ((RETVAL = virConnectNumOfDefinedDomains(con)) < 0) {
	_croak_error(virConnGetLastError(con));
      }
#line 1142 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_defined_domain_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_defined_domain_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1));
#line 705 "Virt.xs"
      char **names;
      int ndom;
      int i;
#line 1168 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_defined_domain_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 709 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((ndom = virConnectListDefinedDomains(con, names, maxnames)) < 0) {
	Safefree(names);
	_croak_error(virConnGetLastError(con));
      }
      EXTEND(SP, ndom);
      for (i = 0 ; i < ndom ; i++) {
	PUSHs(sv_2mortal(newSVpv(names[i], 0)));
        free(names[i]);
      }
      Safefree(names);
#line 1188 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_num_of_networks); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_networks)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_networks() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 726 "Virt.xs"
      if ((RETVAL = virConnectNumOfNetworks(con)) < 0) {
	_croak_error(virConnGetLastError(con));
      }
#line 1220 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_network_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_network_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1));
#line 737 "Virt.xs"
      char **names;
      int i, nnet;
#line 1245 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_network_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 740 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((nnet = virConnectListNetworks(con, names, maxnames)) < 0) {
        Safefree(names);
	_croak_error(virConnGetLastError(con));
      }
      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
	PUSHs(sv_2mortal(newSVpv(names[i], 0)));
	free(names[i]);
      }
      Safefree(names);
#line 1265 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_num_of_defined_networks); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_defined_networks)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_defined_networks() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 757 "Virt.xs"
      if ((RETVAL = virConnectNumOfDefinedNetworks(con)) < 0) {
	_croak_error(virConnGetLastError(con));
      }
#line 1297 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_defined_network_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_defined_network_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1));
#line 768 "Virt.xs"
      char **names;
      int ndom;
      int i;
#line 1323 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_defined_network_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 772 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((ndom = virConnectListDefinedNetworks(con, names, maxnames)) < 0) {
	Safefree(names);
	_croak_error(virConnGetLastError(con));
      }
      EXTEND(SP, ndom);
      for (i = 0 ; i < ndom ; i++) {
	PUSHs(sv_2mortal(newSVpv(names[i], 0)));
        free(names[i]);
      }
      Safefree(names);
#line 1343 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_num_of_storage_pools); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_storage_pools)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_storage_pools() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 789 "Virt.xs"
      if ((RETVAL = virConnectNumOfStoragePools(con)) < 0) {
	_croak_error(virConnGetLastError(con));
      }
#line 1375 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_storage_pool_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_storage_pool_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1));
#line 800 "Virt.xs"
      char **names;
      int i, nnet;
#line 1400 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_storage_pool_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 803 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((nnet = virConnectListStoragePools(con, names, maxnames)) < 0) {
        Safefree(names);
	_croak_error(virConnGetLastError(con));
      }
      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
	PUSHs(sv_2mortal(newSVpv(names[i], 0)));
	free(names[i]);
      }
      Safefree(names);
#line 1420 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_num_of_defined_storage_pools); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_defined_storage_pools)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_defined_storage_pools() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 820 "Virt.xs"
      if ((RETVAL = virConnectNumOfDefinedStoragePools(con)) < 0) {
	_croak_error(virConnGetLastError(con));
      }
#line 1452 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_defined_storage_pool_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_defined_storage_pool_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1));
#line 831 "Virt.xs"
      char **names;
      int ndom;
      int i;
#line 1478 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_defined_storage_pool_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 835 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((ndom = virConnectListDefinedStoragePools(con, names, maxnames)) < 0) {
	Safefree(names);
	_croak_error(virConnGetLastError(con));
      }
      EXTEND(SP, ndom);
      for (i = 0 ; i < ndom ; i++) {
	PUSHs(sv_2mortal(newSVpv(names[i], 0)));
        free(names[i]);
      }
      Safefree(names);
#line 1498 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_num_of_node_devices); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_node_devices)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, cap, flags=0");
    {
	virConnectPtr	con;
	SV *	cap = ST(1);
	int	flags;
#line 854 "Virt.xs"
      const char *capname = NULL;
#line 1521 "Virt.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_node_devices() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(2));
	}
#line 856 "Virt.xs"
      if (SvOK(cap))
	  capname = SvPV_nolen(cap);
      if ((RETVAL = virNodeNumOfDevices(con, capname, flags)) < 0) {
	_croak_error(virConnGetLastError(con));
      }
#line 1543 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_node_device_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_node_device_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "con, cap, maxnames, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	SV *	cap = ST(1);
	int	maxnames = (int)SvIV(ST(2));
	int	flags;
#line 871 "Virt.xs"
      char **names;
      int i, nnet;
      const char *capname = NULL;
#line 1571 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_node_device_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 4)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(3));
	}
#line 875 "Virt.xs"
      if (SvOK(cap))
	  capname = SvPV_nolen(cap);
      Newx(names, maxnames, char *);
      if ((nnet = virNodeListDevices(con, capname, names, maxnames, flags)) < 0) {
        Safefree(names);
	_croak_error(virConnGetLastError(con));
      }
      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
	PUSHs(sv_2mortal(newSVpv(names[i], 0)));
	free(names[i]);
      }
      Safefree(names);
#line 1599 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_num_of_interfaces); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_interfaces)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_interfaces() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 893 "Virt.xs"
      if ((RETVAL = virConnectNumOfInterfaces(con)) < 0) {
	_croak_error(virConnGetLastError(con));
      }
#line 1631 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_interface_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_interface_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1));
#line 904 "Virt.xs"
      char **names;
      int i, nnet;
#line 1656 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_interface_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 907 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((nnet = virConnectListInterfaces(con, names, maxnames)) < 0) {
        Safefree(names);
	_croak_error(virConnGetLastError(con));
      }
      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
	PUSHs(sv_2mortal(newSVpv(names[i], 0)));
	free(names[i]);
      }
      Safefree(names);
#line 1676 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_num_of_defined_interfaces); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_num_of_defined_interfaces)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::num_of_defined_interfaces() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 924 "Virt.xs"
      if ((RETVAL = virConnectNumOfDefinedInterfaces(con)) < 0) {
	_croak_error(virConnGetLastError(con));
      }
#line 1708 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_list_defined_interface_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_list_defined_interface_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1));
#line 935 "Virt.xs"
      char **names;
      int i, nnet;
#line 1733 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::list_defined_interface_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 938 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((nnet = virConnectListDefinedInterfaces(con, names, maxnames)) < 0) {
        Safefree(names);
	_croak_error(virConnGetLastError(con));
      }
      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
	PUSHs(sv_2mortal(newSVpv(names[i], 0)));
	free(names[i]);
      }
      Safefree(names);
#line 1753 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_domain_xml_from_native); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_domain_xml_from_native)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "con, configtype, configdata, flags=0");
    {
	virConnectPtr	con;
	const char *	configtype = (const char *)SvPV_nolen(ST(1));
	const char *	configdata = (const char *)SvPV_nolen(ST(2));
	unsigned int	flags;
#line 958 "Virt.xs"
      char *xmldata;
#line 1777 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::domain_xml_from_native() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3));
	}
#line 960 "Virt.xs"
      if (!(xmldata = virConnectDomainXMLFromNative(con, configtype, configdata, flags))) {
        _croak_error(virConnGetLastError(con));
      }
      RETVAL = newSVpv(xmldata, 0);
      free(xmldata);
#line 1798 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_domain_xml_to_native); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_domain_xml_to_native)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "con, configtype, xmldata, flags=0");
    {
	virConnectPtr	con;
	const char *	configtype = (const char *)SvPV_nolen(ST(1));
	const char *	xmldata = (const char *)SvPV_nolen(ST(2));
	unsigned int	flags;
#line 976 "Virt.xs"
      char *configdata;
#line 1823 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::domain_xml_to_native() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3));
	}
#line 978 "Virt.xs"
      if (!(configdata = virConnectDomainXMLFromNative(con, configtype, xmldata, flags))) {
        _croak_error(virConnGetLastError(con));
      }
      RETVAL = newSVpv(configdata, 0);
      free(configdata);
#line 1844 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt_domain_event_register); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_domain_event_register)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "conref, cb");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	conref = ST(0);
	SV*	cb = ST(1);
#line 992 "Virt.xs"
      AV *opaque;
      virConnectPtr con;
#line 1870 "Virt.c"
#line 995 "Virt.xs"
      con = (virConnectPtr)SvIV((SV*)SvRV(conref));
      opaque = newAV();
      SvREFCNT_inc(cb);
      SvREFCNT_inc(conref);
      av_push(opaque, conref);
      av_push(opaque, cb);
      virConnectDomainEventRegister(con, _domain_event_callback, opaque, _domain_event_free);
#line 1879 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_domain_event_deregister); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_domain_event_deregister)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::domain_event_deregister() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1007 "Virt.xs"
      virConnectDomainEventDeregister(con, _domain_event_callback);
#line 1909 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "con_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	con_rv = ST(0);
#line 1013 "Virt.xs"
      virConnectPtr con;
#line 1932 "Virt.c"
#line 1015 "Virt.xs"
      con = (virConnectPtr)SvIV((SV*)SvRV(con_rv));
      if (con) {
	virConnectClose(con);
	sv_setiv((SV*)SvRV(con_rv), 0);
      }
#line 1939 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain__create_linux); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain__create_linux)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, xml");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::_create_linux() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1028 "Virt.xs"
      /* Don't bother using virDomainCreateXML, since this works
         for more versions */
      if (!(RETVAL = virDomainCreateLinux(con, xml, 0))) {
	_croak_error(virConnGetLastError(con));
      }
#line 1973 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain__define_xml); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain__define_xml)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, xml");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::_define_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1041 "Virt.xs"
      if (!(RETVAL = virDomainDefineXML(con, xml))) {
	_croak_error(virConnGetLastError(con));
      }
#line 2007 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain__lookup_by_id); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain__lookup_by_id)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, id");
    {
	virConnectPtr	con;
	int	id = (int)SvIV(ST(1));
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::_lookup_by_id() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1052 "Virt.xs"
      if (!(RETVAL = virDomainLookupByID(con, id))) {
	_croak_error(virConnGetLastError(con));
      }
#line 2041 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain__lookup_by_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, name");
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1));
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::_lookup_by_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1063 "Virt.xs"
      if (!(RETVAL = virDomainLookupByName(con, name))) {
	_croak_error(virConnGetLastError(con));
      }
#line 2075 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain__lookup_by_uuid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain__lookup_by_uuid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const unsigned char *	uuid = (const unsigned char *)SvPV_nolen(ST(1));
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::_lookup_by_uuid() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1074 "Virt.xs"
      if (!(RETVAL = virDomainLookupByUUID(con, uuid))) {
	_croak_error(virConnGetLastError(con));
      }
#line 2109 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain__lookup_by_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain__lookup_by_uuid_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const char *	uuid = (const char *)SvPV_nolen(ST(1));
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::_lookup_by_uuid_string() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1085 "Virt.xs"
      if (!(RETVAL = virDomainLookupByUUIDString(con, uuid))) {
	_croak_error(virConnGetLastError(con));
      }
#line 2143 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_id); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_id)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_id() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1095 "Virt.xs"
      RETVAL = virDomainGetID(dom);
#line 2175 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_uuid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_uuid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 1104 "Virt.xs"
      unsigned char rawuuid[VIR_UUID_BUFLEN];
#line 2196 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_uuid() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1106 "Virt.xs"
      if ((virDomainGetUUID(dom, rawuuid)) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      RETVAL = newSVpv((char*)rawuuid, sizeof(rawuuid));
#line 2210 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_uuid_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 1117 "Virt.xs"
      char uuid[VIR_UUID_STRING_BUFLEN];
#line 2232 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_uuid_string() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1119 "Virt.xs"
      if ((virDomainGetUUIDString(dom, uuid)) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }

      RETVAL = newSVpv(uuid, 0);
#line 2247 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_name() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1131 "Virt.xs"
      if (!(RETVAL = virDomainGetName(dom))) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2280 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_suspend); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_suspend)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::suspend() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1142 "Virt.xs"
      if ((virDomainSuspend(dom)) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2312 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_resume); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_resume)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::resume() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1151 "Virt.xs"
      if ((virDomainResume(dom)) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2344 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_save); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_save)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "dom, to");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	to = (const char *)SvPV_nolen(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::save() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1161 "Virt.xs"
      if ((virDomainSave(dom, to)) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2377 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_core_dump); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_core_dump)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, to, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	to = (const char *)SvPV_nolen(ST(1));
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::core_dump() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 1171 "Virt.xs"
      if (virDomainCoreDump(dom, to, flags) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2417 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_get_info); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_info)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 1180 "Virt.xs"
      virDomainInfo info;
#line 2438 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_info() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1182 "Virt.xs"
      if (virDomainGetInfo(dom, &info) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "state", 5, newSViv(info.state), 0);
      (void)hv_store (RETVAL, "maxMem", 6, newSViv(info.maxMem), 0);
      (void)hv_store (RETVAL, "memory", 6, newSViv(info.memory), 0);
      (void)hv_store (RETVAL, "nrVirtCpu", 9, newSViv(info.nrVirtCpu), 0);
      (void)hv_store (RETVAL, "cpuTime", 7, virt_newSVull(info.cpuTime), 0);
#line 2457 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_scheduler_parameters); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_scheduler_parameters)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 1199 "Virt.xs"
      virSchedParameter *params;
      int nparams;
      unsigned int i;
      char *type;
#line 2482 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_scheduler_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1204 "Virt.xs"
      if (!(type = virDomainGetSchedulerType(dom, &nparams))) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      free(type);
      Newx(params, nparams, virSchedParameter);
      if (virDomainGetSchedulerParameters(dom, params, &nparams) < 0) {
	Safefree(params);
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      for (i = 0 ; i < nparams ; i++) {
	SV *val = NULL;

	switch (params[i].type) {
	case VIR_DOMAIN_SCHED_FIELD_INT:
	  val = newSViv(params[i].value.i);
	  break;

	case VIR_DOMAIN_SCHED_FIELD_UINT:
	  val = newSViv((int)params[i].value.ui);
	  break;

	case VIR_DOMAIN_SCHED_FIELD_LLONG:
	  val = virt_newSVll(params[i].value.l);
	  break;

	case VIR_DOMAIN_SCHED_FIELD_ULLONG:
	  val = virt_newSVull(params[i].value.ul);
	  break;

	case VIR_DOMAIN_SCHED_FIELD_DOUBLE:
	  val = newSVnv(params[i].value.d);
	  break;

	case VIR_DOMAIN_SCHED_FIELD_BOOLEAN:
	  val = newSViv(params[i].value.b);
	  break;
	}

	(void)hv_store (RETVAL, params[i].field, strlen(params[i].field), val, 0);
      }
      Safefree(params);
#line 2534 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_set_scheduler_parameters); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_set_scheduler_parameters)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "dom, newparams");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	HV *	newparams;
#line 1254 "Virt.xs"
      virSchedParameter *params;
      int nparams;
      unsigned int i;
      char *type;
#line 2562 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::set_scheduler_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (SvROK(ST(1)) && SvTYPE(SvRV(ST(1)))==SVt_PVHV)
	    newparams = (HV*)SvRV(ST(1));
	else
	    Perl_croak(aTHX_ "%s: %s is not a hash reference",
			"Sys::Virt::Domain::set_scheduler_parameters",
			"newparams");
#line 1259 "Virt.xs"
      if (!(type = virDomainGetSchedulerType(dom, &nparams))) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      free(type);
      Newx(params, nparams, virSchedParameter);
      if (virDomainGetSchedulerParameters(dom, params, &nparams) < 0) {
	Safefree(params);
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      for (i = 0 ; i < nparams ; i++) {
	SV **val;

	if (!hv_exists(newparams, params[i].field, strlen(params[i].field)))
	  continue;

	val = hv_fetch (newparams, params[i].field, strlen(params[i].field), 0);

	switch (params[i].type) {
	case VIR_DOMAIN_SCHED_FIELD_INT:
	  params[i].value.i = SvIV(*val);
	  break;

	case VIR_DOMAIN_SCHED_FIELD_UINT:
	  params[i].value.ui = SvIV(*val);
	  break;

	case VIR_DOMAIN_SCHED_FIELD_LLONG:
	  params[i].value.l = virt_SvIVll(*val);
	  break;

	case VIR_DOMAIN_SCHED_FIELD_ULLONG:
	  params[i].value.ul = virt_SvIVull(*val);
	  break;

	case VIR_DOMAIN_SCHED_FIELD_DOUBLE:
	  params[i].value.d = SvNV(*val);
	  break;

	case VIR_DOMAIN_SCHED_FIELD_BOOLEAN:
	  params[i].value.b = SvIV(*val);
	  break;
	}

      }
      if (virDomainSetSchedulerParameters(dom, params, nparams) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      Safefree(params);
#line 2626 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_get_max_memory); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_max_memory)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
	unsigned long	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_max_memory() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1313 "Virt.xs"
      if (!(RETVAL = virDomainGetMaxMemory(dom))) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2658 "Virt.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_set_max_memory); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_set_max_memory)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "dom, val");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned long	val = (unsigned long)SvUV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::set_max_memory() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1324 "Virt.xs"
      if (virDomainSetMaxMemory(dom, val) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2691 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_set_memory); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_set_memory)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "dom, val");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned long	val = (unsigned long)SvUV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::set_memory() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1334 "Virt.xs"
      if (virDomainSetMemory(dom, val) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2724 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_get_max_vcpus); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_max_vcpus)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_max_vcpus() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1342 "Virt.xs"
      if (!(RETVAL = virDomainGetMaxVcpus(dom))) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2756 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_set_vcpus); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_set_vcpus)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "dom, num");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	int	num = (int)SvIV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::set_vcpus() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1354 "Virt.xs"
      if (virDomainSetVcpus(dom, num) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2789 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_set_autostart); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_set_autostart)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "dom, autostart");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	int	autostart = (int)SvIV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::set_autostart() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1364 "Virt.xs"
      if (virDomainSetAutostart(dom, autostart) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2822 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_get_autostart); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_autostart)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 1373 "Virt.xs"
      int autostart;
#line 2843 "Virt.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_autostart() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1375 "Virt.xs"
      if (virDomainGetAutostart(dom, &autostart) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      RETVAL = autostart;
#line 2858 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_scheduler_type); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_scheduler_type)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 1387 "Virt.xs"
      int nparams;
#line 2879 "Virt.c"
	char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_scheduler_type() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1389 "Virt.xs"
      if ((RETVAL = virDomainGetSchedulerType(dom, &nparams)) == NULL) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2893 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_os_type); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_os_type)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 1400 "Virt.xs"
      char *type;
#line 2914 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_os_type() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1402 "Virt.xs"
      if (!(type = virDomainGetOSType(dom))) {
	 _croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      RETVAL = newSVpv(type, 0);
      free(type);
#line 2929 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_xml_description)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 1414 "Virt.xs"
      char *xml;
#line 2951 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_xml_description() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1416 "Virt.xs"
      if (!(xml = virDomainGetXMLDesc(dom, 0))) {
	 _croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 2966 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_shutdown); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_shutdown)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::shutdown() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1428 "Virt.xs"
      if (virDomainShutdown(dom) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 2999 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_reboot); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_reboot)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::reboot() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 1437 "Virt.xs"
      if (virDomainReboot(dom, flags) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 3038 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_undefine); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_undefine)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::undefine() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1445 "Virt.xs"
      if (virDomainUndefine(dom) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 3070 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_create); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_create)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::create() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1453 "Virt.xs"
      if (virDomainCreate(dom) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 3102 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_migrate); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_migrate)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 6)
       croak_xs_usage(cv,  "dom, destcon, flags=0, dname=&PL_sv_undef, uri=&PL_sv_undef, bandwidth=0");
    {
	virDomainPtr	dom;
	virConnectPtr	destcon;
	unsigned long	flags;
	SV *	dname;
	SV *	uri;
	unsigned long	bandwidth;
#line 1467 "Virt.xs"
     const char *dnamestr = NULL;
     const char *uristr = NULL;
#line 3129 "Virt.c"
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::migrate() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        destcon = (virConnectPtr)SvIV((SV*)SvRV( ST(1) ));
    else {
        warn( "Sys::Virt::Domain::migrate() -- destcon is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(2));
	}

	if (items < 4)
	    dname = &PL_sv_undef;
	else {
	    dname = ST(3);
	}

	if (items < 5)
	    uri = &PL_sv_undef;
	else {
	    uri = ST(4);
	}

	if (items < 6)
	    bandwidth = 0;
	else {
	    bandwidth = (unsigned long)SvUV(ST(5));
	}
#line 1470 "Virt.xs"
     if (SvOK(dname))
       dnamestr = SvPV_nolen(dname);
     if (SvOK(uri))
       uristr = SvPV_nolen(uri);

     if ((RETVAL = virDomainMigrate(dom, destcon, flags, dnamestr, uristr, bandwidth)) == NULL) {
       _croak_error(virConnGetLastError(virDomainGetConnect(dom)));
     }
#line 3178 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_attach_device); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_attach_device)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "dom, xml");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	xml = (const char *)SvPV_nolen(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::attach_device() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1486 "Virt.xs"
      if (virDomainAttachDevice(dom, xml) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 3213 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_detach_device); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_detach_device)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "dom, xml");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	xml = (const char *)SvPV_nolen(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::detach_device() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1496 "Virt.xs"
      if (virDomainDetachDevice(dom, xml) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 3246 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_block_stats); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_block_stats)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "dom, path");
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1));
#line 1506 "Virt.xs"
      virDomainBlockStatsStruct stats;
#line 3268 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::block_stats() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1508 "Virt.xs"
      if (virDomainBlockStats(dom, path, &stats, sizeof(stats)) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "rd_req", 6, virt_newSVll(stats.rd_req), 0);
      (void)hv_store (RETVAL, "rd_bytes", 8, virt_newSVll(stats.rd_bytes), 0);
      (void)hv_store (RETVAL, "wr_req", 6, virt_newSVll(stats.wr_req), 0);
      (void)hv_store (RETVAL, "wr_bytes", 8, virt_newSVll(stats.wr_bytes), 0);
      (void)hv_store (RETVAL, "errs", 4, virt_newSVll(stats.errs), 0);
#line 3287 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_interface_stats); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_interface_stats)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "dom, path");
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1));
#line 1526 "Virt.xs"
      virDomainInterfaceStatsStruct stats;
#line 3310 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::interface_stats() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1528 "Virt.xs"
      if (virDomainInterfaceStats(dom, path, &stats, sizeof(stats)) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "rx_bytes", 8, virt_newSVll(stats.rx_bytes), 0);
      (void)hv_store (RETVAL, "rx_packets", 10, virt_newSVll(stats.rx_packets), 0);
      (void)hv_store (RETVAL, "rx_errs", 7, virt_newSVll(stats.rx_errs), 0);
      (void)hv_store (RETVAL, "rx_drop", 7, virt_newSVll(stats.rx_drop), 0);
      (void)hv_store (RETVAL, "tx_bytes", 8, virt_newSVll(stats.tx_bytes), 0);
      (void)hv_store (RETVAL, "tx_packets", 10, virt_newSVll(stats.tx_packets), 0);
      (void)hv_store (RETVAL, "tx_errs", 7, virt_newSVll(stats.tx_errs), 0);
      (void)hv_store (RETVAL, "tx_drop", 7, virt_newSVll(stats.tx_drop), 0);
#line 3332 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_block_peek); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_block_peek)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "dom, path, offset, size, flags=0");
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1));
	unsigned int	offset = (unsigned int)SvUV(ST(2));
	size_t	size = (size_t)SvUV(ST(3));
	unsigned int	flags;
#line 1552 "Virt.xs"
      char *buf;
#line 3358 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::block_peek() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(4));
	}
#line 1554 "Virt.xs"
      Newx(buf, size, char);
      if (virDomainBlockPeek(dom, path, offset, size, buf, flags) < 0) {
	Safefree(buf);
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      RETVAL = newSVpvn(buf, size);
#line 3380 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_memory_peek); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_memory_peek)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, offset, size, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	offset = (unsigned int)SvUV(ST(1));
	size_t	size = (size_t)SvUV(ST(2));
	unsigned int	flags;
#line 1572 "Virt.xs"
      char *buf;
#line 3405 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::memory_peek() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3));
	}
#line 1574 "Virt.xs"
      Newx(buf, size, char);
      if (virDomainMemoryPeek(dom, offset, size, buf, flags) < 0) {
	Safefree(buf);
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      RETVAL = newSVpvn(buf, size);
#line 3427 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_security_label); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_security_label)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 1589 "Virt.xs"
      virSecurityLabel seclabel;
#line 3449 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_security_label() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1591 "Virt.xs"
      if (virDomainGetSecurityLabel(dom, &seclabel) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "label", 5, newSVpv(seclabel.label, 0), 0);
      (void)hv_store (RETVAL, "enforcing", 9, newSViv(seclabel.enforcing), 0);
#line 3465 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Domain_get_vcpu_info); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_get_vcpu_info)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
#line 1605 "Virt.xs"
      virVcpuInfoPtr info;
      unsigned char *cpumaps;
      int maplen;
      virNodeInfo nodeinfo;
      virDomainInfo dominfo;
      int nvCpus;
      int i;
#line 3495 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::get_vcpu_info() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1613 "Virt.xs"
      if (virNodeGetInfo(virDomainGetConnect(dom), &nodeinfo) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
      if (virDomainGetInfo(dom, &dominfo) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }

      Newx(info, dominfo.nrVirtCpu, virVcpuInfo);
      maplen = VIR_CPU_MAPLEN(VIR_NODEINFO_MAXCPUS(nodeinfo));
      Newx(cpumaps, dominfo.nrVirtCpu * maplen, unsigned char);
      if ((nvCpus = virDomainGetVcpus(dom, info, dominfo.nrVirtCpu, cpumaps, maplen)) < 0) {
	Safefree(info);
	Safefree(cpumaps);
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }

      EXTEND(SP, nvCpus);
      for (i = 0 ; i < nvCpus ; i++) {
	HV *rec = newHV();
	(void)hv_store(rec, "number", 6, newSViv(info[i].number), 0);
	(void)hv_store(rec, "state", 5, newSViv(info[i].state), 0);
	(void)hv_store(rec, "cpuTime", 7, virt_newSVull(info[i].cpuTime), 0);
	(void)hv_store(rec, "cpu", 3, newSViv(info[i].cpu), 0);
	(void)hv_store(rec, "affinity", 8, newSVpvn((char*)cpumaps + (i *maplen), maplen), 0);
	PUSHs(newRV_noinc((SV *)rec));
      }

      Safefree(info);
      Safefree(cpumaps);
#line 3533 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_pin_vcpu); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_pin_vcpu)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "dom, vcpu, mask");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	vcpu = (unsigned int)SvUV(ST(1));
	SV *	mask = ST(2);
#line 1650 "Virt.xs"
     STRLEN masklen;
     unsigned char *maps;
#line 3559 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = (virDomainPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Domain::pin_vcpu() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1653 "Virt.xs"
     maps = (unsigned char *)SvPV(mask, masklen);
     if (virDomainPinVcpu(dom, vcpu, maps, masklen) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
     }
#line 3572 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_destroy); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_destroy)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	dom_rv = ST(0);
#line 1663 "Virt.xs"
      virDomainPtr dom;
#line 3595 "Virt.c"
#line 1665 "Virt.xs"
      dom = (virDomainPtr)SvIV((SV*)SvRV(dom_rv));
      if (virDomainDestroy(dom) < 0) {
	_croak_error(virConnGetLastError(virDomainGetConnect(dom)));
      }
#line 3601 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Domain_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Domain_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dom_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	dom_rv = ST(0);
#line 1674 "Virt.xs"
      virDomainPtr dom;
#line 3624 "Virt.c"
#line 1676 "Virt.xs"
      dom = (virDomainPtr)SvIV((SV*)SvRV(dom_rv));
      if (dom) {
	virDomainFree(dom);
	sv_setiv((SV*)SvRV(dom_rv), 0);
      }
#line 3631 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Network__create_xml); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network__create_xml)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, xml");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::_create_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1691 "Virt.xs"
      if (!(RETVAL = virNetworkCreateXML(con, xml))) {
	_croak_error(virConnGetLastError(con));
      }
#line 3663 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Network", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network__define_xml); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network__define_xml)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, xml");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::_define_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1702 "Virt.xs"
      if (!(RETVAL = virNetworkDefineXML(con, xml))) {
	_croak_error(virConnGetLastError(con));
      }
#line 3698 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Network", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network__lookup_by_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, name");
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1));
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::_lookup_by_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1713 "Virt.xs"
      if (!(RETVAL = virNetworkLookupByName(con, name))) {
	_croak_error(virConnGetLastError(con));
      }
#line 3733 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Network", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network__lookup_by_uuid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network__lookup_by_uuid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const unsigned char *	uuid = (const unsigned char *)SvPV_nolen(ST(1));
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::_lookup_by_uuid() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1724 "Virt.xs"
      if (!(RETVAL = virNetworkLookupByUUID(con, uuid))) {
	_croak_error(virConnGetLastError(con));
      }
#line 3768 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Network", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network__lookup_by_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network__lookup_by_uuid_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const char *	uuid = (const char *)SvPV_nolen(ST(1));
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::_lookup_by_uuid_string() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1735 "Virt.xs"
      if (!(RETVAL = virNetworkLookupByUUIDString(con, uuid))) {
	_croak_error(virConnGetLastError(con));
      }
#line 3803 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Network", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network_get_uuid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_get_uuid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	virNetworkPtr	net;
#line 1745 "Virt.xs"
      unsigned char rawuuid[VIR_UUID_BUFLEN];
#line 3827 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::get_uuid() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1747 "Virt.xs"
      if ((virNetworkGetUUID(net, rawuuid)) < 0) {
	_croak_error(virConnGetLastError(virNetworkGetConnect(net)));
      }
      RETVAL = newSVpv((char*)rawuuid, sizeof(rawuuid));
#line 3841 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network_get_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_get_uuid_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	virNetworkPtr	net;
#line 1758 "Virt.xs"
      char uuid[VIR_UUID_STRING_BUFLEN];
#line 3863 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::get_uuid_string() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1760 "Virt.xs"
      if ((virNetworkGetUUIDString(net, uuid)) < 0) {
	_croak_error(virConnGetLastError(virNetworkGetConnect(net)));
      }

      RETVAL = newSVpv(uuid, 0);
#line 3878 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network_get_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_get_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	virNetworkPtr	net;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::get_name() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1772 "Virt.xs"
      if (!(RETVAL = virNetworkGetName(net))) {
	_croak_error(virConnGetLastError(virNetworkGetConnect(net)));
      }
#line 3911 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network_get_bridge_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_get_bridge_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	virNetworkPtr	net;
#line 1783 "Virt.xs"
      char *name;
#line 3932 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::get_bridge_name() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1785 "Virt.xs"
      if (!(name = virNetworkGetBridgeName(net))) {
	 _croak_error(virConnGetLastError(virNetworkGetConnect(net)));
      }
      RETVAL = newSVpv(name, 0);
      free(name);
#line 3947 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_get_xml_description)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	virNetworkPtr	net;
#line 1797 "Virt.xs"
      char *xml;
#line 3969 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::get_xml_description() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1799 "Virt.xs"
      if (!(xml = virNetworkGetXMLDesc(net, 0))) {
	 _croak_error(virConnGetLastError(virNetworkGetConnect(net)));
      }
      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 3984 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network_undefine); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_undefine)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "net");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNetworkPtr	net;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::undefine() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1811 "Virt.xs"
      if (virNetworkUndefine(net) < 0) {
	_croak_error(virConnGetLastError(virNetworkGetConnect(net)));
      }
#line 4017 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Network_create); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_create)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "net");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNetworkPtr	net;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::create() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1819 "Virt.xs"
      if (virNetworkCreate(net) < 0) {
	_croak_error(virConnGetLastError(virNetworkGetConnect(net)));
      }
#line 4049 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Network_set_autostart); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_set_autostart)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "net, autostart");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNetworkPtr	net;
	int	autostart = (int)SvIV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::set_autostart() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1828 "Virt.xs"
      if (virNetworkSetAutostart(net, autostart) < 0) {
	_croak_error(virConnGetLastError(virNetworkGetConnect(net)));
      }
#line 4082 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Network_get_autostart); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_get_autostart)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	virNetworkPtr	net;
#line 1837 "Virt.xs"
      int autostart;
#line 4103 "Virt.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = (virNetworkPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Network::get_autostart() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1839 "Virt.xs"
      if (virNetworkGetAutostart(net, &autostart) < 0) {
	_croak_error(virConnGetLastError(virNetworkGetConnect(net)));
      }
      RETVAL = autostart;
#line 4118 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Network_destroy); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_destroy)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "net_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	net_rv = ST(0);
#line 1850 "Virt.xs"
      virNetworkPtr net;
#line 4141 "Virt.c"
#line 1852 "Virt.xs"
      net = (virNetworkPtr)SvIV((SV*)SvRV(net_rv));
      if (virNetworkDestroy(net) < 0) {
	_croak_error(virConnGetLastError(virNetworkGetConnect(net)));
      }
#line 4147 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Network_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Network_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "net_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	net_rv = ST(0);
#line 1861 "Virt.xs"
      virNetworkPtr net;
#line 4170 "Virt.c"
#line 1863 "Virt.xs"
      net = (virNetworkPtr)SvIV((SV*)SvRV(net_rv));
      if (net) {
	virNetworkFree(net);
	sv_setiv((SV*)SvRV(net_rv), 0);
      }
#line 4177 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StoragePool__create_xml); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool__create_xml)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, xml");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::_create_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1878 "Virt.xs"
      if (!(RETVAL = virStoragePoolCreateXML(con, xml, 0))) {
	_croak_error(virConnGetLastError(con));
      }
#line 4209 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StoragePool", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool__define_xml); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool__define_xml)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, xml");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::_define_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1889 "Virt.xs"
      if (!(RETVAL = virStoragePoolDefineXML(con, xml, 0))) {
	_croak_error(virConnGetLastError(con));
      }
#line 4243 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StoragePool", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool__lookup_by_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, name");
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1));
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::_lookup_by_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1900 "Virt.xs"
      if (!(RETVAL = virStoragePoolLookupByName(con, name))) {
	_croak_error(virConnGetLastError(con));
      }
#line 4277 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StoragePool", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool__lookup_by_uuid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool__lookup_by_uuid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const unsigned char *	uuid = (const unsigned char *)SvPV_nolen(ST(1));
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::_lookup_by_uuid() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1911 "Virt.xs"
      if (!(RETVAL = virStoragePoolLookupByUUID(con, uuid))) {
	_croak_error(virConnGetLastError(con));
      }
#line 4311 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StoragePool", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool__lookup_by_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool__lookup_by_uuid_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const char *	uuid = (const char *)SvPV_nolen(ST(1));
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::_lookup_by_uuid_string() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1922 "Virt.xs"
      if (!(RETVAL = virStoragePoolLookupByUUIDString(con, uuid))) {
	_croak_error(virConnGetLastError(con));
      }
#line 4345 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StoragePool", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool__lookup_by_volume); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool__lookup_by_volume)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "vol");
    {
	virStorageVolPtr	vol;
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = (virStorageVolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::_lookup_by_volume() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1933 "Virt.xs"
      if (!(RETVAL = virStoragePoolLookupByVolume(vol))) {
	_croak_error(virConnGetLastError(virStorageVolGetConnect(vol)));
      }
#line 4378 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StoragePool", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool_get_uuid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_get_uuid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
#line 1944 "Virt.xs"
      unsigned char rawuuid[VIR_UUID_BUFLEN];
#line 4401 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::get_uuid() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1946 "Virt.xs"
      if ((virStoragePoolGetUUID(pool, rawuuid)) < 0) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
      RETVAL = newSVpv((char*)rawuuid, sizeof(rawuuid));
#line 4415 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool_get_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_get_uuid_string)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
#line 1957 "Virt.xs"
      char uuid[VIR_UUID_STRING_BUFLEN];
#line 4437 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::get_uuid_string() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1959 "Virt.xs"
      if ((virStoragePoolGetUUIDString(pool, uuid)) < 0) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }

      RETVAL = newSVpv(uuid, 0);
#line 4452 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool_get_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_get_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::get_name() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1971 "Virt.xs"
      if (!(RETVAL = virStoragePoolGetName(pool))) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
#line 4485 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_get_xml_description)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
#line 1982 "Virt.xs"
      char *xml;
#line 4506 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::get_xml_description() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1984 "Virt.xs"
      if (!(xml = virStoragePoolGetXMLDesc(pool, 0))) {
	 _croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 4521 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool_undefine); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_undefine)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::undefine() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1996 "Virt.xs"
      if (virStoragePoolUndefine(pool) < 0) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
#line 4554 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StoragePool_create); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_create)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::create() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2004 "Virt.xs"
      if (virStoragePoolCreate(pool, 0) < 0) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
#line 4586 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StoragePool_refresh); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_refresh)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pool, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;
	int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::refresh() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1));
	}
#line 2013 "Virt.xs"
      if (virStoragePoolRefresh(pool, flags) < 0) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
#line 4625 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StoragePool_build); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_build)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pool, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;
	int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::build() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1));
	}
#line 2022 "Virt.xs"
      if (virStoragePoolBuild(pool, flags) < 0) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
#line 4664 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StoragePool_delete); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_delete)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pool, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;
	int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::delete() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1));
	}
#line 2031 "Virt.xs"
      if (virStoragePoolDelete(pool, flags) < 0) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
#line 4703 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StoragePool_set_autostart); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_set_autostart)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "pool, autostart");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;
	int	autostart = (int)SvIV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::set_autostart() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2040 "Virt.xs"
      if (virStoragePoolSetAutostart(pool, autostart) < 0) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
#line 4736 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StoragePool_get_autostart); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_get_autostart)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
#line 2049 "Virt.xs"
      int autostart;
#line 4757 "Virt.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::get_autostart() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2051 "Virt.xs"
      if (virStoragePoolGetAutostart(pool, &autostart) < 0) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
      RETVAL = autostart;
#line 4772 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool_get_info); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_get_info)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
#line 2063 "Virt.xs"
      virStoragePoolInfo info;
#line 4793 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::get_info() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2065 "Virt.xs"
      if (virStoragePoolGetInfo(pool, &info) < 0) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "state", 5, newSViv(info.state), 0);
      (void)hv_store (RETVAL, "capacity", 8, virt_newSVull(info.capacity), 0);
      (void)hv_store (RETVAL, "allocation", 10, virt_newSVull(info.allocation), 0);
      (void)hv_store (RETVAL, "available", 9, virt_newSVull(info.available), 0);
#line 4811 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool_destroy); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_destroy)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pool_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	pool_rv = ST(0);
#line 2080 "Virt.xs"
      virStoragePoolPtr pool;
#line 4835 "Virt.c"
#line 2082 "Virt.xs"
      pool = (virStoragePoolPtr)SvIV((SV*)SvRV(pool_rv));
      if (virStoragePoolDestroy(pool) < 0) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
#line 4841 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StoragePool_num_of_storage_volumes); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_num_of_storage_volumes)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::num_of_storage_volumes() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2091 "Virt.xs"
      if ((RETVAL = virStoragePoolNumOfVolumes(pool)) < 0) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
#line 4873 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StoragePool_list_storage_vol_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_list_storage_vol_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "pool, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;
	int	maxnames = (int)SvIV(ST(1));
#line 2102 "Virt.xs"
      char **names;
      int i, nnet;
#line 4898 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StoragePool::list_storage_vol_names() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2105 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((nnet = virStoragePoolListVolumes(pool, names, maxnames)) < 0) {
	Safefree(names);
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
	PUSHs(sv_2mortal(newSVpv(names[i], 0)));
	free(names[i]);
      }
      Safefree(names);
#line 4918 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StoragePool_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StoragePool_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "pool_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	pool_rv = ST(0);
#line 2123 "Virt.xs"
      virStoragePoolPtr pool;
#line 4941 "Virt.c"
#line 2125 "Virt.xs"
      pool = (virStoragePoolPtr)SvIV((SV*)SvRV(pool_rv));
      if (pool) {
	virStoragePoolFree(pool);
	sv_setiv((SV*)SvRV(pool_rv), 0);
      }
#line 4948 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StorageVol__create_xml); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol__create_xml)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "pool, xml, flags=0");
    {
	virStoragePoolPtr	pool;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	int	flags;
	virStorageVolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::_create_xml() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(2));
	}
#line 2140 "Virt.xs"
      if (!(RETVAL = virStorageVolCreateXML(pool, xml, flags))) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
#line 4987 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StorageVol", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StorageVol__create_xml_from); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol__create_xml_from)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "pool, xml, clone, flags=0");
    {
	virStoragePoolPtr	pool;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	virStorageVolPtr	clone;
	int	flags;
	virStorageVolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::_create_xml_from() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

    if (sv_isobject(ST(2)) && (SvTYPE(SvRV(ST(2))) == SVt_PVMG))
        clone = (virStorageVolPtr)SvIV((SV*)SvRV( ST(2) ));
    else {
        warn( "Sys::Virt::StorageVol::_create_xml_from() -- clone is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 4)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(3));
	}
#line 2153 "Virt.xs"
      if (!(RETVAL = virStorageVolCreateXMLFrom(pool, xml, clone, flags))) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
#line 5036 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StorageVol", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StorageVol__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol__lookup_by_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "pool, name");
    {
	virStoragePoolPtr	pool;
	const char *	name = (const char *)SvPV_nolen(ST(1));
	virStorageVolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::_lookup_by_name() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2164 "Virt.xs"
      if (!(RETVAL = virStorageVolLookupByName(pool, name))) {
	_croak_error(virConnGetLastError(virStoragePoolGetConnect(pool)));
      }
#line 5070 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StorageVol", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StorageVol__lookup_by_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol__lookup_by_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, key");
    {
	virConnectPtr	con;
	const char *	key = (const char *)SvPV_nolen(ST(1));
	virStorageVolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::_lookup_by_key() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2175 "Virt.xs"
      if (!(RETVAL = virStorageVolLookupByKey(con, key))) {
	_croak_error(virConnGetLastError(con));
      }
#line 5104 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StorageVol", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StorageVol__lookup_by_path); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol__lookup_by_path)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, path");
    {
	virConnectPtr	con;
	const char *	path = (const char *)SvPV_nolen(ST(1));
	virStorageVolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::_lookup_by_path() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2186 "Virt.xs"
      if (!(RETVAL = virStorageVolLookupByPath(con, path))) {
	_croak_error(virConnGetLastError(con));
      }
#line 5138 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StorageVol", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StorageVol_get_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol_get_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "vol");
    {
	virStorageVolPtr	vol;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = (virStorageVolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::get_name() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2196 "Virt.xs"
      if (!(RETVAL = virStorageVolGetName(vol))) {
	_croak_error(virConnGetLastError(virStorageVolGetConnect(vol)));
      }
#line 5172 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StorageVol_get_key); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol_get_key)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "vol");
    {
	virStorageVolPtr	vol;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = (virStorageVolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::get_key() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2207 "Virt.xs"
      if (!(RETVAL = virStorageVolGetKey(vol))) {
	_croak_error(virConnGetLastError(virStorageVolGetConnect(vol)));
      }
#line 5204 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StorageVol_get_path); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol_get_path)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "vol");
    {
	virStorageVolPtr	vol;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = (virStorageVolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::get_path() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2218 "Virt.xs"
      if (!(RETVAL = virStorageVolGetPath(vol))) {
	_croak_error(virConnGetLastError(virStorageVolGetConnect(vol)));
      }
#line 5236 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StorageVol_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol_get_xml_description)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "vol");
    {
	virStorageVolPtr	vol;
#line 2229 "Virt.xs"
      char *xml;
#line 5257 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = (virStorageVolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::get_xml_description() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2231 "Virt.xs"
      if (!(xml = virStorageVolGetXMLDesc(vol, 0))) {
	 _croak_error(virConnGetLastError(virStorageVolGetConnect(vol)));
      }
      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 5272 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StorageVol_delete); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol_delete)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "vol, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStorageVolPtr	vol;
	int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = (virStorageVolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::delete() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1));
	}
#line 2244 "Virt.xs"
      if (virStorageVolDelete(vol, flags) < 0) {
	_croak_error(virConnGetLastError(virStorageVolGetConnect(vol)));
      }
#line 5312 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__StorageVol_get_info); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol_get_info)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "vol");
    {
	virStorageVolPtr	vol;
#line 2253 "Virt.xs"
      virStorageVolInfo info;
#line 5333 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = (virStorageVolPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::StorageVol::get_info() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2255 "Virt.xs"
      if (virStorageVolGetInfo(vol, &info) < 0) {
	_croak_error(virConnGetLastError(virStorageVolGetConnect(vol)));
      }
      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "type", 4, newSViv(info.type), 0);
      (void)hv_store (RETVAL, "capacity", 8, virt_newSVull(info.capacity), 0);
      (void)hv_store (RETVAL, "allocation", 10, virt_newSVull(info.allocation), 0);
#line 5350 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__StorageVol_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__StorageVol_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "vol_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	vol_rv = ST(0);
#line 2269 "Virt.xs"
      virStorageVolPtr vol;
#line 5374 "Virt.c"
#line 2271 "Virt.xs"
      vol = (virStorageVolPtr)SvIV((SV*)SvRV(vol_rv));
      if (vol) {
	virStorageVolFree(vol);
	sv_setiv((SV*)SvRV(vol_rv), 0);
      }
#line 5381 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__NodeDevice__create_xml); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice__create_xml)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, xml, flags=0");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	unsigned int	flags;
	virNodeDevicePtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NodeDevice::_create_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 2287 "Virt.xs"
      if (!(RETVAL = virNodeDeviceCreateXML(con, xml, flags))) {
	_croak_error(virConnGetLastError(con));
      }
#line 5420 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::NodeDevice", (void*)RETVAL );



    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__NodeDevice__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice__lookup_by_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, name");
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1));
	virNodeDevicePtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NodeDevice::_lookup_by_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2298 "Virt.xs"
      if (!(RETVAL = virNodeDeviceLookupByName(con, name))) {
	_croak_error(virConnGetLastError(con));
      }
#line 5456 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::NodeDevice", (void*)RETVAL );



    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__NodeDevice_get_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice_get_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    {
	virNodeDevicePtr	dev;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = (virNodeDevicePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NodeDevice::get_name() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2308 "Virt.xs"
      if (!(RETVAL = virNodeDeviceGetName(dev))) {
	_croak_error(virGetLastError());
      }
#line 5492 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__NodeDevice_get_parent); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice_get_parent)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    {
	virNodeDevicePtr	dev;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = (virNodeDevicePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NodeDevice::get_parent() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2319 "Virt.xs"
      if (!(RETVAL = virNodeDeviceGetParent(dev))) {
	_croak_error(virGetLastError());
      }
#line 5524 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__NodeDevice_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice_get_xml_description)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    {
	virNodeDevicePtr	dev;
#line 2330 "Virt.xs"
      char *xml;
#line 5545 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = (virNodeDevicePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NodeDevice::get_xml_description() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2332 "Virt.xs"
      if (!(xml = virNodeDeviceGetXMLDesc(dev, 0))) {
	_croak_error(virGetLastError());
      }
      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 5560 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__NodeDevice_dettach); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice_dettach)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNodeDevicePtr	dev;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = (virNodeDevicePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NodeDevice::dettach() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2344 "Virt.xs"
      if (virNodeDeviceDettach(dev) < 0) {
	_croak_error(virGetLastError());
      }
#line 5593 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__NodeDevice_reattach); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice_reattach)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNodeDevicePtr	dev;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = (virNodeDevicePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NodeDevice::reattach() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2352 "Virt.xs"
      if (virNodeDeviceReAttach(dev) < 0) {
	_croak_error(virGetLastError());
      }
#line 5625 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__NodeDevice_reset); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice_reset)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNodeDevicePtr	dev;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = (virNodeDevicePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NodeDevice::reset() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2360 "Virt.xs"
      if (virNodeDeviceReset(dev) < 0) {
	_croak_error(virGetLastError());
      }
#line 5657 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__NodeDevice_list_capabilities); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice_list_capabilities)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNodeDevicePtr	dev;
#line 2368 "Virt.xs"
      int maxnames;
      char **names;
      int i, nnet;
#line 5682 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = (virNodeDevicePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::NodeDevice::list_capabilities() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2372 "Virt.xs"
      if ((maxnames = virNodeDeviceNumOfCaps(dev)) < 0) {
	_croak_error(virGetLastError());
      }
      Newx(names, maxnames, char *);
      if ((nnet = virNodeDeviceListCaps(dev, names, maxnames)) < 0) {
	Safefree(names);
	_croak_error(virGetLastError());
      }
      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
	PUSHs(sv_2mortal(newSVpv(names[i], 0)));
	free(names[i]);
      }
      Safefree(names);
#line 5705 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__NodeDevice_destroy); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice_destroy)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dev_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	dev_rv = ST(0);
#line 2391 "Virt.xs"
      virNodeDevicePtr dev;
#line 5728 "Virt.c"
#line 2393 "Virt.xs"
      dev = (virNodeDevicePtr)SvIV((SV*)SvRV(dev_rv));
      if (virNodeDeviceDestroy(dev) < 0) {
        _croak_error(virGetLastError());
      }
#line 5734 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__NodeDevice_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__NodeDevice_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "dev_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	dev_rv = ST(0);
#line 2403 "Virt.xs"
      virNodeDevicePtr dev;
#line 5757 "Virt.c"
#line 2405 "Virt.xs"
      dev = (virNodeDevicePtr)SvIV((SV*)SvRV(dev_rv));
      if (dev) {
	virNodeDeviceFree(dev);
	sv_setiv((SV*)SvRV(dev_rv), 0);
      }
#line 5764 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Interface__define_xml); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Interface__define_xml)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, xml, flags = 0");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1));
	unsigned int	flags;
	virInterfacePtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Interface::_define_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2));
	}
#line 2421 "Virt.xs"
      if (!(RETVAL = virInterfaceDefineXML(con, xml, flags))) {
	_croak_error(virConnGetLastError(con));
      }
#line 5803 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Interface", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Interface__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Interface__lookup_by_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, name");
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1));
	virInterfacePtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Interface::_lookup_by_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2432 "Virt.xs"
      if (!(RETVAL = virInterfaceLookupByName(con, name))) {
	_croak_error(virConnGetLastError(con));
      }
#line 5837 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Interface", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Interface__lookup_by_mac); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Interface__lookup_by_mac)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "con, mac");
    {
	virConnectPtr	con;
	const char *	mac = (const char *)SvPV_nolen(ST(1));
	virInterfacePtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (virConnectPtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Interface::_lookup_by_mac() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2443 "Virt.xs"
      if (!(RETVAL = virInterfaceLookupByMACString(con, mac))) {
	_croak_error(virConnGetLastError(con));
      }
#line 5871 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Interface", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Interface_get_mac); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Interface_get_mac)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "iface");
    {
	virInterfacePtr	iface;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iface = (virInterfacePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Interface::get_mac() -- iface is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2453 "Virt.xs"
      if (!(RETVAL = virInterfaceGetMACString(iface))) {
	_croak_error(virConnGetLastError(virInterfaceGetConnect(iface)));
      }
#line 5905 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Interface_get_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Interface_get_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "iface");
    {
	virInterfacePtr	iface;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iface = (virInterfacePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Interface::get_name() -- iface is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2463 "Virt.xs"
      if (!(RETVAL = virInterfaceGetName(iface))) {
	_croak_error(virConnGetLastError(virInterfaceGetConnect(iface)));
      }
#line 5937 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Interface_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Interface_get_xml_description)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "iface");
    {
	virInterfacePtr	iface;
#line 2474 "Virt.xs"
      char *xml;
#line 5958 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iface = (virInterfacePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Interface::get_xml_description() -- iface is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2476 "Virt.xs"
      if (!(xml = virInterfaceGetXMLDesc(iface, 0))) {
	 _croak_error(virConnGetLastError(virInterfaceGetConnect(iface)));
      }
      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 5973 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Sys__Virt__Interface_undefine); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Interface_undefine)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "iface");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virInterfacePtr	iface;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iface = (virInterfacePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Interface::undefine() -- iface is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 2488 "Virt.xs"
      if (virInterfaceUndefine(iface) < 0) {
	_croak_error(virConnGetLastError(virInterfaceGetConnect(iface)));
      }
#line 6006 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Interface_create); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Interface_create)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "iface, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virInterfacePtr	iface;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iface = (virInterfacePtr)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Sys::Virt::Interface::create() -- iface is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 2497 "Virt.xs"
      if (virInterfaceCreate(iface, flags) < 0) {
	_croak_error(virConnGetLastError(virInterfaceGetConnect(iface)));
      }
#line 6045 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Interface_destroy); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Interface_destroy)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "iface_rv, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	iface_rv = ST(0);
	unsigned int	flags;
#line 2506 "Virt.xs"
      virInterfacePtr iface;
#line 6069 "Virt.c"

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1));
	}
#line 2508 "Virt.xs"
      iface = (virInterfacePtr)SvIV((SV*)SvRV(iface_rv));
      if (virInterfaceDestroy(iface, flags) < 0) {
	_croak_error(virConnGetLastError(virInterfaceGetConnect(iface)));
      }
#line 6081 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Interface_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Interface_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "iface_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	iface_rv = ST(0);
#line 2517 "Virt.xs"
      virInterfacePtr iface;
#line 6104 "Virt.c"
#line 2519 "Virt.xs"
      iface = (virInterfacePtr)SvIV((SV*)SvRV(iface_rv));
      if (iface) {
	virInterfaceFree(iface);
	sv_setiv((SV*)SvRV(iface_rv), 0);
      }
#line 6111 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Event__register_impl); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Event__register_impl)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 2534 "Virt.xs"
      virEventRegisterImpl(_event_add_handle,
			   _event_update_handle,
			   _event_remove_handle,
			   _event_add_timeout,
			   _event_update_timeout,
			   _event_remove_timeout);
#line 6138 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Event__run_handle_callback_helper); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Event__run_handle_callback_helper)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       croak_xs_usage(cv,  "watch, fd, event, cbref, opaqueref");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	watch = (int)SvIV(ST(0));
	int	fd = (int)SvIV(ST(1));
	int	event = (int)SvIV(ST(2));
	SV *	cbref = ST(3);
	SV *	opaqueref = ST(4);
#line 2549 "Virt.xs"
      virEventHandleCallback cb;
      void *opaque;
#line 6166 "Virt.c"
#line 2552 "Virt.xs"
      cb = (virEventHandleCallback)SvIV((SV*)SvRV(cbref));
      opaque = (void*)SvIV((SV*)SvRV(opaqueref));

      cb(watch, fd, event, opaque);
#line 6172 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Event__run_timeout_callback_helper); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Event__run_timeout_callback_helper)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "timer, cbref, opaqueref");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	timer = (int)SvIV(ST(0));
	SV *	cbref = ST(1);
	SV *	opaqueref = ST(2);
#line 2564 "Virt.xs"
      virEventTimeoutCallback cb;
      void *opaque;
#line 6198 "Virt.c"
#line 2567 "Virt.xs"
      cb = (virEventTimeoutCallback)SvIV((SV*)SvRV(cbref));
      opaque = (void*)SvIV((SV*)SvRV(opaqueref));

      cb(timer, opaque);
#line 6204 "Virt.c"
	PUTBACK;
	return;
    }
}


XS(XS_Sys__Virt__Event__free_callback_opaque_helper); /* prototype to pass -Wmissing-prototypes */
XS(XS_Sys__Virt__Event__free_callback_opaque_helper)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "ffref, opaqueref");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	ffref = ST(0);
	SV *	opaqueref = ST(1);
#line 2578 "Virt.xs"
      virFreeCallback ff;
      void *opaque;
#line 6229 "Virt.c"
#line 2581 "Virt.xs"
      opaque = SvOK(opaqueref) ? (void*)SvIV((SV*)SvRV(opaqueref)) : NULL;
      ff = SvOK(ffref) ? (virFreeCallback)SvIV((SV*)SvRV(ffref)) : NULL;

      if (opaque != NULL && ff != NULL)
        ff(opaque);
#line 6236 "Virt.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Sys__Virt); /* prototype to pass -Wmissing-prototypes */
XS(boot_Sys__Virt)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    const char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXSproto("Sys::Virt::_open", XS_Sys__Virt__open, file, "$$");
        newXSproto("Sys::Virt::_open_auth", XS_Sys__Virt__open_auth, file, "$$$$");
        newXSproto("Sys::Virt::restore_domain", XS_Sys__Virt_restore_domain, file, "$$");
        newXSproto("Sys::Virt::_get_library_version", XS_Sys__Virt__get_library_version, file, "$");
        newXSproto("Sys::Virt::_get_conn_version", XS_Sys__Virt__get_conn_version, file, "$");
        newXSproto("Sys::Virt::get_type", XS_Sys__Virt_get_type, file, "$");
        newXSproto("Sys::Virt::get_uri", XS_Sys__Virt_get_uri, file, "$");
        newXSproto("Sys::Virt::get_node_info", XS_Sys__Virt_get_node_info, file, "$");
        newXSproto("Sys::Virt::get_node_security_model", XS_Sys__Virt_get_node_security_model, file, "$");
        newXSproto("Sys::Virt::get_node_free_memory", XS_Sys__Virt_get_node_free_memory, file, "$");
        newXSproto("Sys::Virt::get_node_cells_free_memory", XS_Sys__Virt_get_node_cells_free_memory, file, "$$$");
        newXSproto("Sys::Virt::find_storage_pool_sources", XS_Sys__Virt_find_storage_pool_sources, file, "$$$;$");
        newXSproto("Sys::Virt::get_capabilities", XS_Sys__Virt_get_capabilities, file, "$");
        newXSproto("Sys::Virt::get_max_vcpus", XS_Sys__Virt_get_max_vcpus, file, "$$");
        newXSproto("Sys::Virt::get_hostname", XS_Sys__Virt_get_hostname, file, "$");
        newXSproto("Sys::Virt::num_of_domains", XS_Sys__Virt_num_of_domains, file, "$");
        newXSproto("Sys::Virt::list_domain_ids", XS_Sys__Virt_list_domain_ids, file, "$$");
        newXSproto("Sys::Virt::num_of_defined_domains", XS_Sys__Virt_num_of_defined_domains, file, "$");
        newXSproto("Sys::Virt::list_defined_domain_names", XS_Sys__Virt_list_defined_domain_names, file, "$$");
        newXSproto("Sys::Virt::num_of_networks", XS_Sys__Virt_num_of_networks, file, "$");
        newXSproto("Sys::Virt::list_network_names", XS_Sys__Virt_list_network_names, file, "$$");
        newXSproto("Sys::Virt::num_of_defined_networks", XS_Sys__Virt_num_of_defined_networks, file, "$");
        newXSproto("Sys::Virt::list_defined_network_names", XS_Sys__Virt_list_defined_network_names, file, "$$");
        newXSproto("Sys::Virt::num_of_storage_pools", XS_Sys__Virt_num_of_storage_pools, file, "$");
        newXSproto("Sys::Virt::list_storage_pool_names", XS_Sys__Virt_list_storage_pool_names, file, "$$");
        newXSproto("Sys::Virt::num_of_defined_storage_pools", XS_Sys__Virt_num_of_defined_storage_pools, file, "$");
        newXSproto("Sys::Virt::list_defined_storage_pool_names", XS_Sys__Virt_list_defined_storage_pool_names, file, "$$");
        newXSproto("Sys::Virt::num_of_node_devices", XS_Sys__Virt_num_of_node_devices, file, "$$;$");
        newXSproto("Sys::Virt::list_node_device_names", XS_Sys__Virt_list_node_device_names, file, "$$$;$");
        newXSproto("Sys::Virt::num_of_interfaces", XS_Sys__Virt_num_of_interfaces, file, "$");
        newXSproto("Sys::Virt::list_interface_names", XS_Sys__Virt_list_interface_names, file, "$$");
        newXSproto("Sys::Virt::num_of_defined_interfaces", XS_Sys__Virt_num_of_defined_interfaces, file, "$");
        newXSproto("Sys::Virt::list_defined_interface_names", XS_Sys__Virt_list_defined_interface_names, file, "$$");
        newXSproto("Sys::Virt::domain_xml_from_native", XS_Sys__Virt_domain_xml_from_native, file, "$$$;$");
        newXSproto("Sys::Virt::domain_xml_to_native", XS_Sys__Virt_domain_xml_to_native, file, "$$$;$");
        newXSproto("Sys::Virt::domain_event_register", XS_Sys__Virt_domain_event_register, file, "$$");
        newXSproto("Sys::Virt::domain_event_deregister", XS_Sys__Virt_domain_event_deregister, file, "$");
        newXSproto("Sys::Virt::DESTROY", XS_Sys__Virt_DESTROY, file, "$");
        newXSproto("Sys::Virt::Domain::_create_linux", XS_Sys__Virt__Domain__create_linux, file, "$$");
        newXSproto("Sys::Virt::Domain::_define_xml", XS_Sys__Virt__Domain__define_xml, file, "$$");
        newXSproto("Sys::Virt::Domain::_lookup_by_id", XS_Sys__Virt__Domain__lookup_by_id, file, "$$");
        newXSproto("Sys::Virt::Domain::_lookup_by_name", XS_Sys__Virt__Domain__lookup_by_name, file, "$$");
        newXSproto("Sys::Virt::Domain::_lookup_by_uuid", XS_Sys__Virt__Domain__lookup_by_uuid, file, "$$");
        newXSproto("Sys::Virt::Domain::_lookup_by_uuid_string", XS_Sys__Virt__Domain__lookup_by_uuid_string, file, "$$");
        newXSproto("Sys::Virt::Domain::get_id", XS_Sys__Virt__Domain_get_id, file, "$");
        newXSproto("Sys::Virt::Domain::get_uuid", XS_Sys__Virt__Domain_get_uuid, file, "$");
        newXSproto("Sys::Virt::Domain::get_uuid_string", XS_Sys__Virt__Domain_get_uuid_string, file, "$");
        newXSproto("Sys::Virt::Domain::get_name", XS_Sys__Virt__Domain_get_name, file, "$");
        newXSproto("Sys::Virt::Domain::suspend", XS_Sys__Virt__Domain_suspend, file, "$");
        newXSproto("Sys::Virt::Domain::resume", XS_Sys__Virt__Domain_resume, file, "$");
        newXSproto("Sys::Virt::Domain::save", XS_Sys__Virt__Domain_save, file, "$$");
        newXSproto("Sys::Virt::Domain::core_dump", XS_Sys__Virt__Domain_core_dump, file, "$$;$");
        newXSproto("Sys::Virt::Domain::get_info", XS_Sys__Virt__Domain_get_info, file, "$");
        newXSproto("Sys::Virt::Domain::get_scheduler_parameters", XS_Sys__Virt__Domain_get_scheduler_parameters, file, "$");
        newXSproto("Sys::Virt::Domain::set_scheduler_parameters", XS_Sys__Virt__Domain_set_scheduler_parameters, file, "$$");
        newXSproto("Sys::Virt::Domain::get_max_memory", XS_Sys__Virt__Domain_get_max_memory, file, "$");
        newXSproto("Sys::Virt::Domain::set_max_memory", XS_Sys__Virt__Domain_set_max_memory, file, "$$");
        newXSproto("Sys::Virt::Domain::set_memory", XS_Sys__Virt__Domain_set_memory, file, "$$");
        newXSproto("Sys::Virt::Domain::get_max_vcpus", XS_Sys__Virt__Domain_get_max_vcpus, file, "$");
        newXSproto("Sys::Virt::Domain::set_vcpus", XS_Sys__Virt__Domain_set_vcpus, file, "$$");
        newXSproto("Sys::Virt::Domain::set_autostart", XS_Sys__Virt__Domain_set_autostart, file, "$$");
        newXSproto("Sys::Virt::Domain::get_autostart", XS_Sys__Virt__Domain_get_autostart, file, "$");
        newXSproto("Sys::Virt::Domain::get_scheduler_type", XS_Sys__Virt__Domain_get_scheduler_type, file, "$");
        newXSproto("Sys::Virt::Domain::get_os_type", XS_Sys__Virt__Domain_get_os_type, file, "$");
        newXSproto("Sys::Virt::Domain::get_xml_description", XS_Sys__Virt__Domain_get_xml_description, file, "$");
        newXSproto("Sys::Virt::Domain::shutdown", XS_Sys__Virt__Domain_shutdown, file, "$");
        newXSproto("Sys::Virt::Domain::reboot", XS_Sys__Virt__Domain_reboot, file, "$;$");
        newXSproto("Sys::Virt::Domain::undefine", XS_Sys__Virt__Domain_undefine, file, "$");
        newXSproto("Sys::Virt::Domain::create", XS_Sys__Virt__Domain_create, file, "$");
        newXSproto("Sys::Virt::Domain::migrate", XS_Sys__Virt__Domain_migrate, file, "$$;$$$$");
        newXSproto("Sys::Virt::Domain::attach_device", XS_Sys__Virt__Domain_attach_device, file, "$$");
        newXSproto("Sys::Virt::Domain::detach_device", XS_Sys__Virt__Domain_detach_device, file, "$$");
        newXSproto("Sys::Virt::Domain::block_stats", XS_Sys__Virt__Domain_block_stats, file, "$$");
        newXSproto("Sys::Virt::Domain::interface_stats", XS_Sys__Virt__Domain_interface_stats, file, "$$");
        newXSproto("Sys::Virt::Domain::block_peek", XS_Sys__Virt__Domain_block_peek, file, "$$$$;$");
        newXSproto("Sys::Virt::Domain::memory_peek", XS_Sys__Virt__Domain_memory_peek, file, "$$$;$");
        newXSproto("Sys::Virt::Domain::get_security_label", XS_Sys__Virt__Domain_get_security_label, file, "$");
        newXSproto("Sys::Virt::Domain::get_vcpu_info", XS_Sys__Virt__Domain_get_vcpu_info, file, "$");
        newXSproto("Sys::Virt::Domain::pin_vcpu", XS_Sys__Virt__Domain_pin_vcpu, file, "$$$");
        newXSproto("Sys::Virt::Domain::destroy", XS_Sys__Virt__Domain_destroy, file, "$");
        newXSproto("Sys::Virt::Domain::DESTROY", XS_Sys__Virt__Domain_DESTROY, file, "$");
        newXSproto("Sys::Virt::Network::_create_xml", XS_Sys__Virt__Network__create_xml, file, "$$");
        newXSproto("Sys::Virt::Network::_define_xml", XS_Sys__Virt__Network__define_xml, file, "$$");
        newXSproto("Sys::Virt::Network::_lookup_by_name", XS_Sys__Virt__Network__lookup_by_name, file, "$$");
        newXSproto("Sys::Virt::Network::_lookup_by_uuid", XS_Sys__Virt__Network__lookup_by_uuid, file, "$$");
        newXSproto("Sys::Virt::Network::_lookup_by_uuid_string", XS_Sys__Virt__Network__lookup_by_uuid_string, file, "$$");
        newXSproto("Sys::Virt::Network::get_uuid", XS_Sys__Virt__Network_get_uuid, file, "$");
        newXSproto("Sys::Virt::Network::get_uuid_string", XS_Sys__Virt__Network_get_uuid_string, file, "$");
        newXSproto("Sys::Virt::Network::get_name", XS_Sys__Virt__Network_get_name, file, "$");
        newXSproto("Sys::Virt::Network::get_bridge_name", XS_Sys__Virt__Network_get_bridge_name, file, "$");
        newXSproto("Sys::Virt::Network::get_xml_description", XS_Sys__Virt__Network_get_xml_description, file, "$");
        newXSproto("Sys::Virt::Network::undefine", XS_Sys__Virt__Network_undefine, file, "$");
        newXSproto("Sys::Virt::Network::create", XS_Sys__Virt__Network_create, file, "$");
        newXSproto("Sys::Virt::Network::set_autostart", XS_Sys__Virt__Network_set_autostart, file, "$$");
        newXSproto("Sys::Virt::Network::get_autostart", XS_Sys__Virt__Network_get_autostart, file, "$");
        newXSproto("Sys::Virt::Network::destroy", XS_Sys__Virt__Network_destroy, file, "$");
        newXSproto("Sys::Virt::Network::DESTROY", XS_Sys__Virt__Network_DESTROY, file, "$");
        newXSproto("Sys::Virt::StoragePool::_create_xml", XS_Sys__Virt__StoragePool__create_xml, file, "$$");
        newXSproto("Sys::Virt::StoragePool::_define_xml", XS_Sys__Virt__StoragePool__define_xml, file, "$$");
        newXSproto("Sys::Virt::StoragePool::_lookup_by_name", XS_Sys__Virt__StoragePool__lookup_by_name, file, "$$");
        newXSproto("Sys::Virt::StoragePool::_lookup_by_uuid", XS_Sys__Virt__StoragePool__lookup_by_uuid, file, "$$");
        newXSproto("Sys::Virt::StoragePool::_lookup_by_uuid_string", XS_Sys__Virt__StoragePool__lookup_by_uuid_string, file, "$$");
        newXSproto("Sys::Virt::StoragePool::_lookup_by_volume", XS_Sys__Virt__StoragePool__lookup_by_volume, file, "$");
        newXSproto("Sys::Virt::StoragePool::get_uuid", XS_Sys__Virt__StoragePool_get_uuid, file, "$");
        newXSproto("Sys::Virt::StoragePool::get_uuid_string", XS_Sys__Virt__StoragePool_get_uuid_string, file, "$");
        newXSproto("Sys::Virt::StoragePool::get_name", XS_Sys__Virt__StoragePool_get_name, file, "$");
        newXSproto("Sys::Virt::StoragePool::get_xml_description", XS_Sys__Virt__StoragePool_get_xml_description, file, "$");
        newXSproto("Sys::Virt::StoragePool::undefine", XS_Sys__Virt__StoragePool_undefine, file, "$");
        newXSproto("Sys::Virt::StoragePool::create", XS_Sys__Virt__StoragePool_create, file, "$");
        newXSproto("Sys::Virt::StoragePool::refresh", XS_Sys__Virt__StoragePool_refresh, file, "$;$");
        newXSproto("Sys::Virt::StoragePool::build", XS_Sys__Virt__StoragePool_build, file, "$;$");
        newXSproto("Sys::Virt::StoragePool::delete", XS_Sys__Virt__StoragePool_delete, file, "$;$");
        newXSproto("Sys::Virt::StoragePool::set_autostart", XS_Sys__Virt__StoragePool_set_autostart, file, "$$");
        newXSproto("Sys::Virt::StoragePool::get_autostart", XS_Sys__Virt__StoragePool_get_autostart, file, "$");
        newXSproto("Sys::Virt::StoragePool::get_info", XS_Sys__Virt__StoragePool_get_info, file, "$");
        newXSproto("Sys::Virt::StoragePool::destroy", XS_Sys__Virt__StoragePool_destroy, file, "$");
        newXSproto("Sys::Virt::StoragePool::num_of_storage_volumes", XS_Sys__Virt__StoragePool_num_of_storage_volumes, file, "$");
        newXSproto("Sys::Virt::StoragePool::list_storage_vol_names", XS_Sys__Virt__StoragePool_list_storage_vol_names, file, "$$");
        newXSproto("Sys::Virt::StoragePool::DESTROY", XS_Sys__Virt__StoragePool_DESTROY, file, "$");
        newXSproto("Sys::Virt::StorageVol::_create_xml", XS_Sys__Virt__StorageVol__create_xml, file, "$$;$");
        newXSproto("Sys::Virt::StorageVol::_create_xml_from", XS_Sys__Virt__StorageVol__create_xml_from, file, "$$$;$");
        newXSproto("Sys::Virt::StorageVol::_lookup_by_name", XS_Sys__Virt__StorageVol__lookup_by_name, file, "$$");
        newXSproto("Sys::Virt::StorageVol::_lookup_by_key", XS_Sys__Virt__StorageVol__lookup_by_key, file, "$$");
        newXSproto("Sys::Virt::StorageVol::_lookup_by_path", XS_Sys__Virt__StorageVol__lookup_by_path, file, "$$");
        newXSproto("Sys::Virt::StorageVol::get_name", XS_Sys__Virt__StorageVol_get_name, file, "$");
        newXSproto("Sys::Virt::StorageVol::get_key", XS_Sys__Virt__StorageVol_get_key, file, "$");
        newXSproto("Sys::Virt::StorageVol::get_path", XS_Sys__Virt__StorageVol_get_path, file, "$");
        newXSproto("Sys::Virt::StorageVol::get_xml_description", XS_Sys__Virt__StorageVol_get_xml_description, file, "$");
        newXSproto("Sys::Virt::StorageVol::delete", XS_Sys__Virt__StorageVol_delete, file, "$;$");
        newXSproto("Sys::Virt::StorageVol::get_info", XS_Sys__Virt__StorageVol_get_info, file, "$");
        newXSproto("Sys::Virt::StorageVol::DESTROY", XS_Sys__Virt__StorageVol_DESTROY, file, "$");
        newXSproto("Sys::Virt::NodeDevice::_create_xml", XS_Sys__Virt__NodeDevice__create_xml, file, "$$;$");
        newXSproto("Sys::Virt::NodeDevice::_lookup_by_name", XS_Sys__Virt__NodeDevice__lookup_by_name, file, "$$");
        newXSproto("Sys::Virt::NodeDevice::get_name", XS_Sys__Virt__NodeDevice_get_name, file, "$");
        newXSproto("Sys::Virt::NodeDevice::get_parent", XS_Sys__Virt__NodeDevice_get_parent, file, "$");
        newXSproto("Sys::Virt::NodeDevice::get_xml_description", XS_Sys__Virt__NodeDevice_get_xml_description, file, "$");
        newXSproto("Sys::Virt::NodeDevice::dettach", XS_Sys__Virt__NodeDevice_dettach, file, "$");
        newXSproto("Sys::Virt::NodeDevice::reattach", XS_Sys__Virt__NodeDevice_reattach, file, "$");
        newXSproto("Sys::Virt::NodeDevice::reset", XS_Sys__Virt__NodeDevice_reset, file, "$");
        newXSproto("Sys::Virt::NodeDevice::list_capabilities", XS_Sys__Virt__NodeDevice_list_capabilities, file, "$");
        newXSproto("Sys::Virt::NodeDevice::destroy", XS_Sys__Virt__NodeDevice_destroy, file, "$");
        newXSproto("Sys::Virt::NodeDevice::DESTROY", XS_Sys__Virt__NodeDevice_DESTROY, file, "$");
        newXSproto("Sys::Virt::Interface::_define_xml", XS_Sys__Virt__Interface__define_xml, file, "$$;$");
        newXSproto("Sys::Virt::Interface::_lookup_by_name", XS_Sys__Virt__Interface__lookup_by_name, file, "$$");
        newXSproto("Sys::Virt::Interface::_lookup_by_mac", XS_Sys__Virt__Interface__lookup_by_mac, file, "$$");
        newXSproto("Sys::Virt::Interface::get_mac", XS_Sys__Virt__Interface_get_mac, file, "$");
        newXSproto("Sys::Virt::Interface::get_name", XS_Sys__Virt__Interface_get_name, file, "$");
        newXSproto("Sys::Virt::Interface::get_xml_description", XS_Sys__Virt__Interface_get_xml_description, file, "$");
        newXSproto("Sys::Virt::Interface::undefine", XS_Sys__Virt__Interface_undefine, file, "$");
        newXSproto("Sys::Virt::Interface::create", XS_Sys__Virt__Interface_create, file, "$;$");
        newXSproto("Sys::Virt::Interface::destroy", XS_Sys__Virt__Interface_destroy, file, "$;$");
        newXSproto("Sys::Virt::Interface::DESTROY", XS_Sys__Virt__Interface_DESTROY, file, "$");
        newXSproto("Sys::Virt::Event::_register_impl", XS_Sys__Virt__Event__register_impl, file, "");
        newXSproto("Sys::Virt::Event::_run_handle_callback_helper", XS_Sys__Virt__Event__run_handle_callback_helper, file, "$$$$$");
        newXSproto("Sys::Virt::Event::_run_timeout_callback_helper", XS_Sys__Virt__Event__run_timeout_callback_helper, file, "$$$");
        newXSproto("Sys::Virt::Event::_free_callback_opaque_helper", XS_Sys__Virt__Event__free_callback_opaque_helper, file, "$$");

    /* Initialisation Section */

#line 2596 "Virt.xs"
    {
      HV *stash;

      virSetErrorFunc(NULL, ignoreVirErrorFunc);

      stash = gv_stashpv( "Sys::Virt", TRUE );

      /*
       * Not required
      RGISTER_CONSTANT(VIR_CONNECT_RO, CONNECT_RO);
      */

      REGISTER_CONSTANT(VIR_CRED_USERNAME, CRED_USERNAME);
      REGISTER_CONSTANT(VIR_CRED_AUTHNAME, CRED_AUTHNAME);
      REGISTER_CONSTANT(VIR_CRED_LANGUAGE, CRED_LANGUAGE);
      REGISTER_CONSTANT(VIR_CRED_CNONCE, CRED_CNONCE);
      REGISTER_CONSTANT(VIR_CRED_PASSPHRASE, CRED_PASSPHRASE);
      REGISTER_CONSTANT(VIR_CRED_ECHOPROMPT, CRED_ECHOPROMPT);
      REGISTER_CONSTANT(VIR_CRED_NOECHOPROMPT, CRED_NOECHOPROMPT);
      REGISTER_CONSTANT(VIR_CRED_REALM, CRED_REALM);
      REGISTER_CONSTANT(VIR_CRED_EXTERNAL, CRED_EXTERNAL);


      stash = gv_stashpv( "Sys::Virt::Event", TRUE );

      REGISTER_CONSTANT(VIR_EVENT_HANDLE_READABLE, HANDLE_READABLE);
      REGISTER_CONSTANT(VIR_EVENT_HANDLE_WRITABLE, HANDLE_WRITABLE);
      REGISTER_CONSTANT(VIR_EVENT_HANDLE_ERROR, HANDLE_ERROR);
      REGISTER_CONSTANT(VIR_EVENT_HANDLE_HANGUP, HANDLE_HANGUP);


      stash = gv_stashpv( "Sys::Virt::Domain", TRUE );
      REGISTER_CONSTANT(VIR_DOMAIN_NOSTATE, STATE_NOSTATE);
      REGISTER_CONSTANT(VIR_DOMAIN_RUNNING, STATE_RUNNING);
      REGISTER_CONSTANT(VIR_DOMAIN_BLOCKED, STATE_BLOCKED);
      REGISTER_CONSTANT(VIR_DOMAIN_PAUSED, STATE_PAUSED);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTDOWN, STATE_SHUTDOWN);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF, STATE_SHUTOFF);
      REGISTER_CONSTANT(VIR_DOMAIN_CRASHED, STATE_CRASHED);

      /*
       * This constant is not really useful yet
      REGISTER_CONSTANT(VIR_DOMAIN_NONE, CREATE_NONE);
      */

      /* NB: skip VIR_DOMAIN_SCHED_FIELD_* constants, because
         those are not used from Perl code - handled internally
         in the XS layer */

      REGISTER_CONSTANT(VIR_MIGRATE_LIVE, MIGRATE_LIVE);


      REGISTER_CONSTANT(VIR_DOMAIN_XML_SECURE, XML_SECURE);
      REGISTER_CONSTANT(VIR_DOMAIN_XML_INACTIVE, XML_INACTIVE);

      REGISTER_CONSTANT(VIR_MEMORY_VIRTUAL, MEMORY_VIRTUAL);

      REGISTER_CONSTANT(VIR_VCPU_OFFLINE, VCPU_OFFLINE);
      REGISTER_CONSTANT(VIR_VCPU_RUNNING, VCPU_RUNNING);
      REGISTER_CONSTANT(VIR_VCPU_BLOCKED, VCPU_BLOCKED);


      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_DEFINED, EVENT_DEFINED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_UNDEFINED, EVENT_UNDEFINED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STARTED, EVENT_STARTED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED, EVENT_SUSPENDED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_RESUMED, EVENT_RESUMED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED, EVENT_STOPPED);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_DEFINED_ADDED, EVENT_DEFINED_ADDED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_DEFINED_UPDATED, EVENT_DEFINED_UPDATED);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_UNDEFINED_REMOVED, EVENT_UNDEFINED_REMOVED);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STARTED_BOOTED, EVENT_STARTED_BOOTED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STARTED_MIGRATED, EVENT_STARTED_MIGRATED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STARTED_RESTORED, EVENT_STARTED_RESTORED);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED_PAUSED, EVENT_SUSPENDED_PAUSED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED_MIGRATED, EVENT_SUSPENDED_MIGRATED);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_RESUMED_UNPAUSED, EVENT_RESUMED_UNPAUSED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_RESUMED_MIGRATED, EVENT_RESUMED_MIGRATED);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_SHUTDOWN, EVENT_STOPPED_SHUTDOWN);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_DESTROYED, EVENT_STOPPED_DESTROYED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_CRASHED, EVENT_STOPPED_CRASHED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_MIGRATED, EVENT_STOPPED_MIGRATED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_SAVED, EVENT_STOPPED_SAVED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_FAILED, EVENT_STOPPED_FAILED);



      stash = gv_stashpv( "Sys::Virt::StoragePool", TRUE );
      REGISTER_CONSTANT(VIR_STORAGE_POOL_INACTIVE, STATE_INACTIVE);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_BUILDING, STATE_BUILDING);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_RUNNING, STATE_RUNNING);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_DEGRADED, STATE_DEGRADED);

      REGISTER_CONSTANT(VIR_STORAGE_POOL_BUILD_NEW, BUILD_NEW);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_BUILD_REPAIR, BUILD_REPAIR);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_BUILD_RESIZE, BUILD_RESIZE);

      REGISTER_CONSTANT(VIR_STORAGE_POOL_DELETE_NORMAL, DELETE_NORMAL);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_DELETE_ZEROED, DELETE_ZEROED);


      stash = gv_stashpv( "Sys::Virt::StorageVol", TRUE );
      REGISTER_CONSTANT(VIR_STORAGE_VOL_FILE, TYPE_FILE);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_BLOCK, TYPE_BLOCK);

      REGISTER_CONSTANT(VIR_STORAGE_VOL_DELETE_NORMAL, DELETE_NORMAL);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_DELETE_ZEROED, DELETE_ZEROED);


      stash = gv_stashpv( "Sys::Virt::Error", TRUE );
      REGISTER_CONSTANT(VIR_FROM_NONE, FROM_NONE);
      REGISTER_CONSTANT(VIR_FROM_XEN, FROM_XEN);
      REGISTER_CONSTANT(VIR_FROM_XEND, FROM_XEND);
      REGISTER_CONSTANT(VIR_FROM_XENSTORE, FROM_XENSTORE);
      REGISTER_CONSTANT(VIR_FROM_SEXPR, FROM_SEXPR);
      REGISTER_CONSTANT(VIR_FROM_XML, FROM_XML);
      REGISTER_CONSTANT(VIR_FROM_DOM, FROM_DOM);
      REGISTER_CONSTANT(VIR_FROM_RPC, FROM_RPC);
      REGISTER_CONSTANT(VIR_FROM_PROXY, FROM_PROXY);
      REGISTER_CONSTANT(VIR_FROM_CONF, FROM_CONF);
      REGISTER_CONSTANT(VIR_FROM_QEMU, FROM_QEMU);
      REGISTER_CONSTANT(VIR_FROM_NET, FROM_NET);
      REGISTER_CONSTANT(VIR_FROM_TEST, FROM_TEST);
      REGISTER_CONSTANT(VIR_FROM_REMOTE, FROM_REMOTE);
      REGISTER_CONSTANT(VIR_FROM_OPENVZ, FROM_OPENVZ);
      REGISTER_CONSTANT(VIR_FROM_XENXM, FROM_XENXM);
      REGISTER_CONSTANT(VIR_FROM_STATS_LINUX, FROM_STATS_LINUX);
      REGISTER_CONSTANT(VIR_FROM_LXC, FROM_LXC);
      REGISTER_CONSTANT(VIR_FROM_STORAGE, FROM_STORAGE);
      REGISTER_CONSTANT(VIR_FROM_NETWORK, FROM_NETWORK);
      REGISTER_CONSTANT(VIR_FROM_DOMAIN, FROM_DOMAIN);
      REGISTER_CONSTANT(VIR_FROM_UML, FROM_UML);
      REGISTER_CONSTANT(VIR_FROM_NODEDEV, FROM_NODEDEV);
      REGISTER_CONSTANT(VIR_FROM_XEN_INOTIFY, FROM_XEN_INOTIFY);
      REGISTER_CONSTANT(VIR_FROM_SECURITY, FROM_SECURITY);



      REGISTER_CONSTANT(VIR_ERR_OK, ERR_OK);
      REGISTER_CONSTANT(VIR_ERR_INTERNAL_ERROR, ERR_INTERNAL_ERROR);
      REGISTER_CONSTANT(VIR_ERR_NO_MEMORY, ERR_NO_MEMORY);
      REGISTER_CONSTANT(VIR_ERR_NO_SUPPORT, ERR_NO_SUPPORT);
      REGISTER_CONSTANT(VIR_ERR_UNKNOWN_HOST, ERR_UNKNOWN_HOST);
      REGISTER_CONSTANT(VIR_ERR_NO_CONNECT, ERR_NO_CONNECT);
      REGISTER_CONSTANT(VIR_ERR_INVALID_CONN, ERR_INVALID_CONN);
      REGISTER_CONSTANT(VIR_ERR_INVALID_DOMAIN, ERR_INVALID_DOMAIN);
      REGISTER_CONSTANT(VIR_ERR_INVALID_ARG, ERR_INVALID_ARG);
      REGISTER_CONSTANT(VIR_ERR_OPERATION_FAILED, ERR_OPERATION_FAILED);
      REGISTER_CONSTANT(VIR_ERR_GET_FAILED, ERR_GET_FAILED);
      REGISTER_CONSTANT(VIR_ERR_POST_FAILED, ERR_POST_FAILED);
      REGISTER_CONSTANT(VIR_ERR_HTTP_ERROR, ERR_HTTP_ERROR);
      REGISTER_CONSTANT(VIR_ERR_SEXPR_SERIAL, ERR_SEXPR_SERIAL);
      REGISTER_CONSTANT(VIR_ERR_NO_XEN, ERR_NO_XEN);
      REGISTER_CONSTANT(VIR_ERR_XEN_CALL, ERR_XEN_CALL);
      REGISTER_CONSTANT(VIR_ERR_OS_TYPE, ERR_OS_TYPE);
      REGISTER_CONSTANT(VIR_ERR_NO_KERNEL, ERR_NO_KERNEL);
      REGISTER_CONSTANT(VIR_ERR_NO_ROOT, ERR_NO_ROOT);
      REGISTER_CONSTANT(VIR_ERR_NO_SOURCE, ERR_NO_SOURCE);
      REGISTER_CONSTANT(VIR_ERR_NO_TARGET, ERR_NO_TARGET);
      REGISTER_CONSTANT(VIR_ERR_NO_NAME, ERR_NO_NAME);
      REGISTER_CONSTANT(VIR_ERR_NO_OS, ERR_NO_OS);
      REGISTER_CONSTANT(VIR_ERR_NO_DEVICE, ERR_NO_DEVICE);
      REGISTER_CONSTANT(VIR_ERR_NO_XENSTORE, ERR_NO_XENSTORE);
      REGISTER_CONSTANT(VIR_ERR_DRIVER_FULL, ERR_DRIVER_FULL);
      REGISTER_CONSTANT(VIR_ERR_CALL_FAILED, ERR_CALL_FAILED);
      REGISTER_CONSTANT(VIR_ERR_XML_ERROR, ERR_XML_ERROR);
      REGISTER_CONSTANT(VIR_ERR_DOM_EXIST, ERR_DOM_EXIST);
      REGISTER_CONSTANT(VIR_ERR_OPERATION_DENIED, ERR_OPERATIONED_DENIED);
      REGISTER_CONSTANT(VIR_ERR_OPEN_FAILED, ERR_OPEN_FAILED);
      REGISTER_CONSTANT(VIR_ERR_READ_FAILED, ERR_READ_FAILED);
      REGISTER_CONSTANT(VIR_ERR_PARSE_FAILED, ERR_PARSE_FAILED);
      REGISTER_CONSTANT(VIR_ERR_CONF_SYNTAX, ERR_CONF_SYNTAX);
      REGISTER_CONSTANT(VIR_ERR_WRITE_FAILED, ERR_WRITE_FAILED);
      REGISTER_CONSTANT(VIR_ERR_XML_DETAIL, ERR_XML_DETAIL);
      REGISTER_CONSTANT(VIR_ERR_INVALID_NETWORK, ERR_INVALID_NETWORK);
      REGISTER_CONSTANT(VIR_ERR_NETWORK_EXIST, ERR_NETWORK_EXIST);
      REGISTER_CONSTANT(VIR_ERR_SYSTEM_ERROR, ERR_SYSTEM_ERROR);
      REGISTER_CONSTANT(VIR_ERR_RPC, ERR_RPC);
      REGISTER_CONSTANT(VIR_ERR_GNUTLS_ERROR, ERR_GNUTLS_ERROR);
      REGISTER_CONSTANT(VIR_WAR_NO_NETWORK, WAR_NO_NETWORK);
      REGISTER_CONSTANT(VIR_ERR_NO_DOMAIN, ERR_NO_DOMAIN);
      REGISTER_CONSTANT(VIR_ERR_NO_NETWORK, ERR_NO_NETWORK);
      REGISTER_CONSTANT(VIR_ERR_INVALID_MAC, ERR_INVALID_MAC);
      REGISTER_CONSTANT(VIR_ERR_AUTH_FAILED, ERR_AUTH_FAILED);
      REGISTER_CONSTANT(VIR_ERR_INVALID_STORAGE_POOL, ERR_INVALID_STORAGE_POOL);
      REGISTER_CONSTANT(VIR_ERR_INVALID_STORAGE_VOL, ERR_INVALID_STORAGE_VOL);
      REGISTER_CONSTANT(VIR_WAR_NO_STORAGE, WAR_NO_STORAGE);
      REGISTER_CONSTANT(VIR_ERR_NO_STORAGE_POOL, ERR_NO_STORAGE_POOL);
      REGISTER_CONSTANT(VIR_ERR_NO_STORAGE_VOL, ERR_NO_STORAGE_VOL);
      REGISTER_CONSTANT(VIR_WAR_NO_NODE, WAR_NO_NODE);
      REGISTER_CONSTANT(VIR_ERR_INVALID_NODE_DEVICE, ERR_INVALID_NODE_DEVICE);
      REGISTER_CONSTANT(VIR_ERR_NO_NODE_DEVICE, ERR_NO_NODE_DEVICE);
      REGISTER_CONSTANT(VIR_ERR_NO_SECURITY_MODEL, ERR_NO_SECURITY_MODEL);
      REGISTER_CONSTANT(VIR_ERR_OPERATION_INVALID, ERR_OPERATION_INVALID);
      REGISTER_CONSTANT(VIR_WAR_NO_INTERFACE, WAR_NO_INTERFACE);
      REGISTER_CONSTANT(VIR_ERR_NO_INTERFACE, ERR_NO_INTERFACE);
      REGISTER_CONSTANT(VIR_ERR_INVALID_INTERFACE, ERR_INVALID_INTERFACE);
    }

#line 6624 "Virt.c"

    /* End of Initialisation Section */

    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

